#!/usr/bin/perl -w

# gernerate cipux_task_* man pages
# (c) 2005, 2006 Christian Kuelker
# License: GPLv2 or later

use lib "./src/lib";
use CipUX::Task;

my $dir = shift || "../debian/cipux-cibot";

# * my directory is:  /tmp/BUILD/cipux-3.1.0/cibot
# * my builddir is : ../debian/cipux-cibot
# * task           : cipux_task_create_user
# * options        : 6,4:UID,firstname,lastname,role,
#                    password;default_CID,uhquota,ghquota,
#                    usquota,gsquota

print " * my directory is:  ";
print qx(pwd);
print " * my builddir is : $dir\n";
$cmd = "mkdir -p $dir/usr/share/man/man1";
print  "$cmd\n";
qx($cmd);

$cmd = "mkdir -p $dir/usr/share/doc/cipux-cibot/html";
print  "$cmd\n";
qx($cmd);

my $date = qx(date --iso-8601);
chomp($date);
my $api_file = "$dir/usr/share/doc/cipux-cibot/cipux_rpc_api.txt";
open(F,">$api_file") or die "Cant write $api_file!\n";
print F "CipUX XML-RPC API Documentation $date\n";
print F "==========================================\n\n";
print F "Under Perl Frontier::Client the return value on success is:\n";
print F " * a reference to an array (if the output is a list, see cipux_task_list_*)\n";
print F " * a string if the output is a single value\n";
print F " * nothing\n";
print F "When the return value is an error, the XML-RPC type 'fault' is used.\n";
print F "For a `fault' type, the `value' array contains a hash with the two \n";
print F "members `faultCode' and `faultMessage'.     \n";
print F "See also cipux_rpcd man page!\n";
close(F);

foreach my $task (keys %task){
  print "="x76 ."\n";
  print " * task          : $task\n";
  print " * options       : $task{$task}\n";
  my $cmd = 'perl -e \'use lib "./src/lib";';
  $cmd   .= 'use CipUX::Task;taskusage("';
  $cmd   .= $task.'");\'';
  print "$cmd\n";
  @usage = qx($cmd);
  my @api = @usage;
  &write_api($task,\@api,$api_file);
  $usage = join('  ',@usage);
  my $pod = &generate_pod($task,"  ".$usage);
  my $file = "$dir/usr/share/man/man1/$task.pod";
  my @pod = split(/\n/,$pod);
  foreach(@pod){
    s/^\s+$//g;
    #        s%/%E<sol>%g;
  }
  $pod = join("\n",@pod);
  open(POD,"> $file")
    or die "can't open $file for writing!\n";
  print "Write POD to file [$file]\n";
  print POD $pod;
      close(POD);
  if(! -e $file){
    print "ERROR file $file do nOT exist\n";
    exit(255);
  }
  #  debian/cipux-cibot.links
  $cmd = "echo '/usr/bin/cipux_task /usr/bin/$task' >> ../debian/cipux-cibot.links";
  print  "$cmd\n";
  qx($cmd);
  $cmd = "podchecker $file";
  print  "$cmd\n";
  qx($cmd);
  # create man
  $cmd = "pod2man --verbose --name $task --center 'CipUX Documentation' $file $dir/usr/share/man/man1/$task.1";
  print  "$cmd\n";
  qx($cmd);
  # compress man
  $cmd = "gzip -f9 $dir/usr/share/man/man1/$task.1";
  print  "$cmd\n";
  qx($cmd);
  # create html
  $cmd = "pod2html --verbose --title $task --infile=$file --outfile=$dir/usr/share/doc/cipux-cibot/html/$task.html";
  print  "$cmd\n";
  # remove temp POD file
  qx($cmd);
  $cmd = "rm $file";
  print  "$cmd\n";
  qx($cmd);

}
exit(0);

sub write_api {
  my $f= shift; # function
  my $usage_aref=shift;
  my $file = shift;

  #qx(rm $file) if -e $file;
  foreach(@$usage_aref) {
    chomp;
    open(F,">>$file") or die "cant open file $file for writing\n";
    #----------------------------------------------------------------------------
    #USAGE:
    #
    #  cipux_task_restore_user_homedir [OPTIONS]
    #
    #EXPLANION:
    #
    #    * 1 mandatory options:
    #        UID (login: user ID, example: chkuelker)
    #
    #   * 2 auxilliary options:
    #        homedirpath;skel_UID ()
    #
    #    * 2 other options:
    #        -h (this page)
    #        --help (this page)
    #
    #EXAMPLES:
    #
    #  1) cipux_task_restore_user_homedir UID
    #  2) cipux_task_restore_user_homedir UID homedirpath skel_UID
    #  3) cipux_task_restore_user_homedir -h
    #  4) cipux_task_restore_user_homedir --help
    # ----------------------------------------------------------------------------

    s/CipWorX CipUX CiBot Task//g;
    s/USAGE:/FUNCTION $f:\n/g;
    s/$f.+\[OPTIONS\]/\$return = $f(\$login,\$ticket,\[OTHER PARAMETER]);/g;
    s/EXPLANION:/\n\nOTHER PARAMETER:\n/g;
    s/EXAMPLES:/\n\nEXAMPLES:\n/g;
    s/ \* \d auxilliary options:/  \* 1 auxilliary options:/;
    s/if using without password, you will be ask for password//g;
    s/.*echo 'password'.*//g;
    s/^.*2 other options:.*//g;
    s/^.*h \(this page\).*//g;
    s/^.*help \(this page\).*//g;
    s/^.*$f -h//g;
    s/^.*$f --help//g;
    m/$f (.*)/;
    my $arg =$1;
    my @arg=();
    @arg=split(/ /,$arg)if defined $arg;
    foreach(@arg){$_="\$$_"}
    my $args = join(", ",@arg);
    s/$f .*/\$return = $f(\$login, \$ticket, $args);/g;
    s/\d\)/  /g;
    print F "$_\n" if $_ ne "";
    close(F);
  }
}


sub generate_pod{
  my $caller = shift;
  my $usage = shift;

  my $pod="

=head1 NAME

$caller

=head1 SYNOPSIS

  $caller

or

  $caller [OPTIONS]

This command depends on the CipUX::Task module. For
details, please see the L<USAGE> section below.

=head1 DESCRIPTION

This script provides a specifc CipUX::Task which
should be self explaining by the name of the script. 
if not, you are an important person for the CipUX 
team, because we can work together to improve CipUX!
Please join the team: we have chat, mailing lists,
wikis.

=head1 REQUIREMENTS

Perl modules:

CipUX::Task

=head1 USAGE

$caller is a perl script which provide a specific
CipUX task and may be used as follows:

$usage

=cut


=head1 SEE ALSO

See the CipUX webpage and the manual at L<http://www.cipux.org>

See the mailing list L<http://www.cipux.org/mailman/listinfo/>

See the CipUX manual pages online L<http://man.cipux.org/>

=head1 AUTHOR

Christian Kuelker  E<lt>christian.kuelker\@cipworx.orgE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 1999-2006 by Christian Kuelker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
MA 02110-1301, USA.

=cut

";

  return $pod;
}



