<?

/** ********************************************************************************************* **/
/**                                                                                               **/
/** functions.php                                                                                 **/
/**                                                                                               **/
/** Author : Jean-Charles Siegel, jeancharles.siegel@gmail.com                                    **/
/**                                                                                               **/
/** Year : 2006                                                                                   **/
/**                                                                                               **/
/** Licence : GPLv2                                                                               **/
/**                                                                                               **/
/** Edited for : Debian Edu/Skolelinux, CipUX                                                     **/
/**                                                                                               **/
/** Description : This file defines php functions which are usefull for all the web application   **/
/**                                                                                               **/
/** ********************************************************************************************* **/

// if the function doesn't exists then create it
if (!function_exists('get_string')) {
	function get_string ($index,$file) {
		// get browser lang parameter
		$lang = $_SERVER['HTTP_ACCEPT_LANGUAGE'][0].$_SERVER['HTTP_ACCEPT_LANGUAGE'][1];
		include ("../lang/$lang/$file.php");
		return $string[$index];
	}
}

//function which lists the members of a group a display them
function listMembers ($groupName, $cipux) {
	//call the XML RPC function which lists the group's members, and getting the results
	$res = $cipux->list_user_members_of_course($groupName);
	// if there are results (=members in the group), then displaying the results
	if ($res) {
		sort($res);
		echo'
		<table width="100%">
		<tr>
			<th width="33%" class="header c1" style="text-align:left"><a name="group_selected"></a>'.get_string('account','cipuxPHP').'</th>
			<th width="33%" class="header c1" style="text-align:left">'.get_string('firstname','cipuxPHP').' &amp; '.get_string('lastname','cipuxPHP').'</th>
			<th width="33%" class="header c1" style="text-align:left">'.get_string('type','cipuxPHP').'</th>
		</tr>';
		
		for ($i = 0 ; $i < sizeof($res) ; $i++) {
			// get the firstname and lastname of each user and next their role
			$name = $cipux->tell_me_user_canonical_name($res[$i]);
			$role = $cipux->tell_me_user_role($res[$i])
			if ($i%2) $back = "#ddd"; else $back = "#ccc";
			echo'
			<tr style="background:'.$back.'">
				<td width="33%" style="text-align:left">'.$res[$i].'</td>
				<td width="33%" style="text-align:left">'.$name[0].'</td>
				<td width="33%" style="text-align:left">'.get_string($role[0],'cipuxPHP').'</td>
			</tr>';
		}
		echo '<tr>
			<td colspan="3" align="center" class="header c1">
				<form method="post" action="">
					<input type="hidden" name="page" value="groups_manager.php" />
					<input type="submit" name="submit" value="'.get_string('close_list','cipuxPHP').'" />
				</form>
			</td>
		</tr>
		</table>';
	}
}

//function which permits to add members in the group, it lists the users who are not in the group
function addMembers ($groupName, $cipux) {
	// we list all the users and users who are members of this group
	$result1 = $cipux->list_users();
	$result2 = $cipux->list_user_members_of_course($groupName);
	
	// and then we list users without the members of the group
	$j=0;
	for ($i=0 ; $i<sizeof($result1) ; $i++) {
		if (!in_array($result1[$i], $result2)) {
			$result[$j] = $result1[$i];
			$j++;
		}
	}
	
	sort($result);
	
	// finally we display the users who are not in the groups and can be added in it
	echo'
	<form method="post" action ="add_members_to_goup.php">
	<table width="100%">
	<tr>
		<th width="10%" class="header c1" style="text-align:left"><a name="group_selected"></a>'.get_string('selection','cipuxPHP').'</th>
		<th width="45%" class="header c1" style="text-align:left">'.get_string('account','cipuxPHP').'</th>
		<th width="33%" class="header c1" style="text-align:left">'.get_string('firstname','cipuxPHP').' &amp; '.get_string('lastname','cipuxPHP').'</th>
		<th width="45%" class="header c1" style="text-align:left">'.get_string('type','cipuxPHP').'</th>
	</tr>';
	
	for ($i = 0 ; $i < sizeof($result); $i++) {
		// get the firstname and lastname of each user
		$name = $cipux->tell_me_user_canonical_name($result[$i]);
		$role = $cipux->tell_me_user_role($result[$i]);
		if ($i%2) $back = "#ddd"; else $back = "#ccc";
		echo '
		<tr style="background:'.$back.'">
		<td width="10%" style="text-align:left"><input type="checkbox" name="add'.$i.'" value="'.$result[$i].'"/></td>
		<td width="45%" style="text-align:left">'.$result[$i].'</td>
		<td width="45%" style="text-align:left">'.$name[0].'</td>
		<td width="45%" style="text-align:left">'.get_string($role[0],'cipuxPHP').'</td>
	</tr>';
	}
	echo '
	<tr>
		<td colspan="4" align="center" class="header c1">
			<input type="hidden" name="groupname" value="'.$groupName.'"/>
			<input type="hidden" name="nbmembers" value="'.sizeof($result).'"/>
			<input type="submit" name="submit" value="'.get_string('add','cipuxPHP').'" />
			<input type="button" name="submit" value="'.get_string('cancel','cipuxPHP').'" onclick="javascript:history.back();"/>
		</td>	
	</tr>
	</table>
	</form>';
}

//function which permits to remove members from a group, it lists the users who are in the group
function removeMembers ($groupName, $cipux) {
	$res = $cipux->list_user_members_of_course($groupName);
	// if there are users in the group, so we display them
	if ($res) {
		sort($res);
		
		echo'
		<form method="post" action ="remove_members_from_group.php">
		<table width="100%">
		<tr>
			<th width="10%" class="header c1" style="text-align:left"><a name="group_selected"></a>'.get_string('selection','cipuxPHP').'</th>
			<th width="45%" class="header c1" style="text-align:left">'.get_string('account','cipuxPHP').'</th>
			<th width="33%" class="header c1" style="text-align:left">'.get_string('firstname','cipuxPHP').' &amp; '.get_string('lastname','cipuxPHP').'</th>
			<th width="45%" class="header c1" style="text-align:left">'.get_string('type','cipuxPHP').'</th>
		</tr>';
		
		for ($i = 0 ; $i < sizeof($res) ; $i++) {
			
			$name = $cipux->tell_me_user_canonical_name($res[$i]);
			$role = $cipux->tell_me_user_role($res[$i]);
			if ($i%2) $back = "#ddd"; else $back = "#ccc";
			echo '
			<tr style="background:'.$back.'">
				<td width="10%" style="text-align:left"><input type="checkbox" name="rem'.$i.'" value="'.$res[$i].'"/></td>
				<td width="45%" style="text-align:left">'.$res[$i].'</td>
				<td width="45%" style="text-align:left">'.$name[0].'</td>
				<td width="45%" style="text-align:left">'.get_string($role[0],'cipuxPHP').'</td>
			</tr>';
		}
		echo '
		<tr>
			<td colspan="4" align="center" class="header c1">
				<input type="hidden" name="groupname" value="'.$groupName.'"/>
				<input type="hidden" name="nbmembers" value="'.sizeof($res).'"/>
				<input type="submit" name="submit" value="'.get_string('remove','cipuxPHP').'" />
				<input type="button" name="submit" value="'.get_string('cancel','cipuxPHP').'" onclick="javascript:history.back();"/>
			</td>
		</tr>
		</table>
		</form>';
	}
}

// this function is used to change the group passeword, it display 2 editboxes to get the new password
function editGroup ($groupName, $color) {
	echo'
	<form method="post" action ="">
		<input type="hidden" name="page" value="groups_manager.php" />
		<input type="hidden" name="groupname" value="'.$groupName.'" />
		<tr '.$color.'><td width="20%"><a name="group_selected"></a>'.$groupName.'</td>
		<td width="20%">
			<table><tr><td>
				<input type="password" name="password1"/>
			</td><td>
				<input type="password" name="password2"/>
			</td></tr></table>
		</td>
		<td width="60%">
		<table>
			<tr>
				<td><input type="submit" name="valid_edit" value="'.get_string('valid','cipuxPHP').'"/></td>
				<td>
				<input type="submit" name="cancel" value="'.get_string('cancel','cipuxPHP').'"/></td>
			</tr>
		</table>
		</td></tr>
	</form>';
}

// A function which edit the log file, she is called in the page index.php
function edit_log_file ($page, $pers) {
	// get current date
	$date = date("d M Y");
	// get current time
	$time = date("H:i:s");
	// open the file with adding option => "a"
	$file = fopen("log","a+");
	
	switch ($page) {
		case 'menu.php' : $page = get_string('main_menu','cipuxPHP'); break;
		case 'user_creator.php' : $page = get_string('user_creator','cipuxPHP'); break;
		case 'users_manager.php' : $page = get_string('users_manager','cipuxPHP'); break;
		case 'group_creator.php' : $page = get_string('group_creator','cipuxPHP'); break;
		case 'groups_manager.php' : $page = get_string('groups_manager','cipuxPHP'); break;
		case 'internet_access_manager.php' : $page = get_string('internet_access_manager','cipuxPHP'); break;
		case 'select_class.php' : $page = get_string('in_upper_class','cipuxPHP'); break;
		case 'go_in_upper_class.php' : $page = get_string('in_upper_class','cipuxPHP'); break;
		case 'log.php' : $page = get_string('log','cipuxPHP'); break;
		case 'users_role_manager.php' : $page = get_string('users_role_manager','cipuxPHP'); break;
	}
	
	// operation to get the number of line
	$nb_lines = 0;
	while(!feof($file)) {
		// get a line of the file 
		fgets($file);	
		// increase the number of line
		$nb_lines++;
	}
	
	// in function of the number of line the nex line will be colored in gray or in white
	if ($nb_lines%2 == 0) $color = 'style="background:#eee"';
	else $color = '';
	
	// write a new line in the file with current date and time, user's name and lastname, and the visited page
	fputs($file, '<tr '.$color.'><td>'.$date.'</td><td>'.$time.'</td><td>'.$pers.'</td><td>'.$page.'</td></tr>'."\n"); 
	// close the file
	fclose($file);
}

// function which sets the expired time for the ticket
function set_time () {
	// get hour, minute and second
	$hour = date("H");
	$minute = date("i");
	$second = date("s");
	// add 20 minutes (because the ticket live 20 minutes)
	$minute = $minute + 20;
	
	// test if minutes are over 60, then add an hour
	if ($minute>=60) {
		$minute = $minute % 60;

		if (sizeof($minute) == 1) {
			$minute = "O".$minute;
		}
		$hour = ($hour + 1) % 24;
	}
	
	// then return the expired time
	return $hour.":".$minute.":".$second;
}

?> 