<?
/** ********************************************************************************************* **/
/**                                                                                               **/
/** go_in_upper_class.php                                                                         **/
/**                                                                                               **/
/** Author : Jean-Charles Siegel, jeancharles.siegel@gmail.com                                    **/
/**                                                                                               **/
/** Year : 2006                                                                                   **/
/**                                                                                               **/
/** Licence : GPLv2                                                                               **/
/**                                                                                               **/
/** Edited for : Debian Edu/Skolelinux, CipUX                                                     **/
/**                                                                                               **/
/** Description : This script is used to take students who are in the year X and put them in the  **/
/**               year X+1. But before you have to select the year X and the year X+1 in the      **/
/**               script select_class.php. Year = class                                           **/
/**                                                                                               **/
/** ********************************************************************************************* **/

// this function display all the students of a given list because all the users in this list are student
function display_students_list($student_list, $cipux) {
	for ($i=0 ; $i<sizeof($student_list) ; $i++) {
		// before displaying the students we get their firstname and their lastname
		$firstname = $cipux->tell_me_user_firstname($student_list[$i]);
		$lastname = $cipux->tell_me_user_lastname($student_list[$i]);
		// then displaying
		echo '
		<tr'.( ($i%2) ? ' style="background:#eee"' : '' ).'>
		<td><input type="checkbox" name="uid'.$i.'" value="'.$student_list[$i].'"/></td>
		<td> '.$firstname[0].'</td>
		<td> '.$lastname[0].'</td>
		</tr>';
	}
}
 
// test of the year X and X+1, they can not be equal
if ($_POST['class1'] != $_POST['class2']) {

	// if they are different it's good !!
	$different = true;
	
	// here is the part that add students in the year X+1 and remove them from the year X
	if (isset($_POST['submit_right'])) {
		for ($i=0; $i<$_POST['nbuser1']; $i++){
			if (isset($_POST['uid'.$i])) {
				$cipux->remove_user_from_course($_POST['class1'], $_POST['uid'.$i]);
				$cipux->add_user_to_course($_POST['class2'], $_POST['uid'.$i]);
			}
		}
	}
	
	// here is the part that add students in the year X and remove them from the year X+1
	// this part is used if users have done a mistake
	if (isset($_POST['submit_left'])) {
		for ($i=0; $i<$_POST['nbuser2']; $i++){
			if (isset($_POST['uid'.$i])){
				$cipux->remove_user_from_course($_POST['class2'], $_POST['uid'.$i]);
				$cipux->add_user_to_course($_POST['class1'], $_POST['uid'.$i]);
			}
		}
	}
	
	// here is the part that lists the students who are in the year X and in the year X+1 without the teachers
	// 1) listing of all the students who are existing
	// 2) listing of the users of the year X
	// 3) listing only the students of the year X
	// 4) listing of the users of the year X+1
	// 5) listing only the students of the year X+1
	$list_students = $cipux->list_students(); 
	$res1 = $cipux->list_user_members_of_course($_POST['class1']);
	for ($i=0 ; $i<sizeof($res1) ; $i++) {
		if (in_array($res1[$i], $list_students)) {
			$result1[$i] = $res1[$i];
		}
	}
	if ($result1) sort($result1);
	$res2 = $cipux->list_user_members_of_course($_POST['class2']);
	for ($i=0 ; $i<sizeof($res2) ; $i++) {
		if (in_array($res2[$i], $list_students)) {
			$result2[$i] = $res2[$i];
		}
	}
	if ($result2) sort($result2);
}
else $different = false;
?>
<table align="center" width="70%" class="generalbox" border="0" cellpadding="20" cellspacing="0"><tr><td  class="generalboxcontent">
<h3><? echo (get_string('in_upper_class','cipuxPHP')); ?></h3>


<?
// if the classes are different
if ($different) { 
?>
<form method="post" action="">
	<!-- these are all the data we need for adding and removing students from the year X and X+1 -->
	<input type="hidden" name="page" value="go_in_upper_class.php"/>
	<input type="hidden" name="class1" value="<? echo($_POST['class1']); ?>"/>
	<input type="hidden" name="class2" value="<? echo($_POST['class2']); ?>"/>
	<input type="hidden" name="nbuser1" value="<? echo(sizeof($result1)); ?>"/>
	<input type="hidden" name="nbuser2" value="<? echo(sizeof($result2)); ?>"/>
	<!-- End of hidden data -->
	<table width="100%">
	<tr>
		<td valign="top">
			<h5 align="center"> <? echo(get_string('select2','cipuxPHP').' : '.$_POST['class1']); ?> </h5>
			
			<table>
				<tr>
					<th width="10%" class="header c1" style="text-align:left"><a href=""><? echo (get_string('selection','cipuxPHP'));?></a></th>
					<th width="10%" class="header c1" style="text-align:left"><a href=""><? echo (get_string('firstname','cipuxPHP'));?></a></th>
					<th width="10%" class="header c1" style="text-align:left"><a href=""><? echo (get_string('lastname','cipuxPHP'));?></a></th>
				</tr>
				<?
				display_students_list($result1, $cipux);
				?>
			</table>
		</td>
		<td>
			<p></p>
			<table>
				<tr><td>
					<!-- this is the button which removes students in the year X+1 and adds them in the yeay X -->
					<input type="submit" name="submit_right" value="&gt;&gt;" title="<? echo (get_string('info1','cipuxPHP'));?>"/>
				</td></tr>
				<tr><td>&nbsp;</td></tr>
				<tr><td>
					<!-- this is the button which removes students in the year X+1 and adds them in the yeay X -->
					<input type="submit" name="submit_left" value="&lt;&lt;" title="<? echo (get_string('info2','cipuxPHP'));?>"/>
				</td></tr>
			</table>
		</td>
		<td valign="top">
			<h5 align="center"> <? echo(get_string('select3','cipuxPHP').' : '.$_POST['class2']); ?> </h5>
		
			<table>
				<tr>
					<th width="10%" class="header c1" style="text-align:left"><a href=""><? echo (get_string('selection','cipuxPHP'));?></a></th>
					<th width="10%" class="header c1" style="text-align:left"><a href=""><? echo (get_string('firstname','cipuxPHP'));?></a></th>
					<th width="10%" class="header c1" style="text-align:left"><a href=""><? echo (get_string('lastname','cipuxPHP'));?></a></th>
				</tr>
				<?
				display_students_list($result2, $cipux);
				?>
			</table>
		</td>
	</tr>
	</table>
</form>
<?} else {echo ('<p align="center"><font color="red">'.get_string('error6','cipuxPHP').'</font></p>');}
include ('return.php');?>
</td></tr></table>  