<?

/** ********************************************************************************************* **/
/**                                                                                               **/
/** groups_manager.php                                                                            **/
/**                                                                                               **/
/** Author : Jean-Charles Siegel, jeancharles.siegel@gmail.com                                    **/
/**                                                                                               **/
/** Year : 2006                                                                                   **/
/**                                                                                               **/
/** Licence : GPLv2                                                                               **/
/**                                                                                               **/
/** Edited for : Debian Edu/Skolelinux, CipUX                                                     **/
/**                                                                                               **/
/** Description : This script is used to manage the groups. Kind of actions you will do : list    **/
/**               users of a group, add users in a group, remove users from a group, change the   **/
/**               password of a group and delete a group                                          **/
/**                                                                                               **/
/** Warnings : this part of script is not valid on w3c validator when you want to change the      **/
/**            group password.                                                                          **/
/**            Number of errors : 3                                                               **/
/**                                                                                               **/
/** ********************************************************************************************* **/

//deleting a group, this action is execute if the button delete is clicked
if (isset($_POST['submit_delete'])) {
	$result = $cipux->delete_course($_POST['groupname']);
	if ($result) {$msg = '<font color="green">'.get_string('delete_group_ok','cipuxPHP').'</font>';}
	else {$msg = '<font color="red">'.get_string('delete_group_error','cipuxPHP').'</font>';}
}

// changing a group password, the both can't be empty and have to be the same
// if they are empty or not the same then error message
// this action is execute if the button modify is clicked
if (isset($_POST['valid_edit'])) {
	if (!empty($_POST['password1'])) {
		if (!empty($_POST['password2'])) {
			if ($_POST['password1'] == $_POST['password2']) {
				$result = $cipux->change_course_password($_POST['groupname'], $_POST['password2']);
				if ($result)
					$msg = '<font color="green">'.get_string('change_group_password_ok','cipuxPHP').'</font>';
				else
					$msg = '<font color="red">'.get_string('change_group_password_error','cipuxPHP').'</font>';
			}
			else {
				$msg = '<font color="red">'.get_string('error5','cipuxPHP').'</font>';
			}
		}
		else {
			$msg = '<font color="red">'.get_string('error4','cipuxPHP').'</font>';
		}
	}
	else {
		$msg = '<font color="red">'.get_string('error3','cipuxPHP').'</font>';
	}
}
?>

<table align="center" width="100%" class="generalbox" border="0" cellpadding="20" cellspacing="0">
<tr><td  class="generalboxcontent">
<h3><? echo (get_string('groups_manager','cipuxPHP')); ?></h3>

	<p align="center"><? echo ($msg); ?></p>
	<table class="generalbox" style="width:100%">
	<tr>
		<th width="20%" class="header c1" style="text-align:left"><a href="#"><? echo (get_string('groups_name','cipuxPHP')); ?></a></th>
		<th width="20%" class="header c1" style="text-align:left"><a href="#"><? echo (get_string('password','cipuxPHP')); ?></a></th>
		<th width="60%" class="header c1" style="text-align:left"><a href="#"><? echo (get_string('actions','cipuxPHP')); ?></a></th>
	</tr>
	
	<?
	// here we list all the classes
	$result = $cipux->list_courses();
	
	$array_length = sizeof($result);
	sort($result);
	for ($i = 0 ; $i < $array_length ; $i++) { 
		$color = "";
		if ($i%2) $color = ' style="background:#eee"';
		
		// if the button edit is clicked we called the function editGroup to change the password
		if (isset($_POST['submit_edit']) && $_POST['user_id'] == $result[$i])
			editGroup($result[$i],$color);
		else { // else we display the group normaly
	?>
	<tr <? echo $color; ?>>
	<!-- Display all the groups by using XML RPC function that lists them -->
		<td width="20%"><? echo($result[$i]); ?></td>
		<td width="20%">*******</td>
		<td width="60%">
			<table>  
				<tr>
					<td>
						<!-- this is the form used to call the function which lists the group's users -->
						<form action="index.php#group_selected" method="post" name="listMembersForm">
							<input type="hidden" name="page" value="groups_manager.php" />
							<input type="hidden" name="user_id" value="<? echo ($result[$i]); ?>" />
							<input type="submit" name="submit_list" value="<? echo (get_string('list_members','cipuxPHP')); ?>"/>
						</form>
					</td>
					<td>
						<!-- this is the form used to call the function which permits to add users -->
						<form action="index.php#group_selected" method="post" name="addMembersForm">
							<input type="hidden" name="page" value="groups_manager.php" />
							<input type="hidden" name="user_id" value="<? echo ($result[$i]); ?>" />
							<input type="submit" name="submit_add" value="<? echo (get_string('add_members','cipuxPHP')); ?>"/>
						</form>
					</td>
					<td>
						<!-- this is the form used to call the function which permits to remove users -->
						<form action="index.php#group_selected" method="post" name="removeMembersForm">
							<input type="hidden" name="page" value="groups_manager.php" />
							<input type="hidden" name="user_id" value="<? echo ($result[$i]); ?>" />
							<input type="submit" name="submit_remove" value="<? echo (get_string('remove_members','cipuxPHP')); ?>"/>
						</form>
					</td>
					<td>
						<!-- this is the form which call the function used to modify the password -->
						<form action="index.php#group_selected" method="post" name="modifForm">
							<input type="hidden" name="page" value="groups_manager.php" />
							<input type="hidden" name="user_id" value="<? echo ($result[$i]); ?>" />
							<input type="submit" name="submit_edit" value="<? echo (get_string('edit','cipuxPHP')); ?>"/>
						</form>
					</td>
					<td>
						<!-- this is the form which delete a group -->
						<form action="" method="post" name="deleteForm">
							<input type="hidden" name="page" value="groups_manager.php" />
							<input type="hidden" name="groupname" value="<? echo ($result[$i]); ?>" />
							<input type="submit" name="submit_delete" value="<? echo (get_string('delete','cipuxPHP')); ?>" onclick="javascript:return window.confirm('<? echo(get_string('confirm2','cipuxPHP'));?>');" />
						</form>
					</td>
				</tr>
			</table>
		</td>
	</tr>
	<? 
		}
		// if the button list members is clicked
		if (isset($_POST['submit_list']) && $_POST['user_id'] == $result[$i]){
			echo ('<tr><td colspan="3"');
			listMembers($result[$i], $cipux);
			echo('</td></tr>');
		}
		// if the button add members is clicked
		else if (isset($_POST['submit_add']) && $_POST['user_id'] == $result[$i]){
			echo ('<tr><td colspan="3"');
			addMembers($result[$i], $cipux);
			echo('</td></tr>');
		}
		// if the button remove members is clicked
		else if (isset($_POST['submit_remove']) && $_POST['user_id'] == $result[$i]) {
			echo ('<tr><td colspan="3"');
			removeMembers($result[$i], $cipux);
			echo('</td></tr>');
		}
	}
	?>
	</table>
<? include('return.php') ?>
</td></tr></table>