<?php
/** ********************************************************************************************* **/
/**                                                                                               **/
/** index.php                                                                                     **/
/**                                                                                               **/
/** Author : Jean-Charles Siegel, jeancharles.siegel@gmail.com                                    **/
/**                                                                                               **/
/** Year : 2006                                                                                   **/
/**                                                                                               **/
/** Licence : GPLv2                                                                               **/
/**                                                                                               **/
/** Edited for : Debian Edu/Skolelinux, CipUX                                                     **/
/**                                                                                               **/
/** This is the main page, we never leave it, generaly we don't use $_GET but more $_POST to      **/
/** navigate between the tools the header and the footer nerver change, it's just the middle of   **/
/** the page which changes                                                                        **/
/**                                                                                               **/
/** ********************************************************************************************* **/

// checking if the version.php file exists and then if it is moodle
if (file_exists('../version.php')) {
	$file = file ('../version.php');
	if (in_array("// MOODLE VERSION INFORMATION\n", $file)) {
		$cms = 'moodle_';
		$is_moodle = true;
	}
}

// including the header 
include ('header-footer/'.$cms.'header.php');

// including the functions file
include ('functions.php');

// include the cipux.php file
include ('cipux.php');
// creating an instance of the class cipux_xml
$cipux = new cipux_xml(); 

// if the session is not created 
if (!isset($_SESSION['cipux'])) {
	if (isset($_POST['submit_ident']) && !empty($_POST['login']) && !empty($_POST['pass'])){
		// log in to the server and get the ticket
		if ($ticket = $cipux->rpc_login($_POST['login'], $_POST['pass'])) {
			$_SESSION['cipux'] = $ticket; 
			$_SESSION['login_cipux'] = $_POST['login']; // get the user uid
			$_SESSION['expire'] = set_time();  // set the time when the session expire on the server
		}
		else $_SESSION['error'] = get_string('no_server','cipuxPHP');
	}
	if (!isset($_SESSION['cipux'])) include('login.php');
}
else {
	// testing if the session has expired then log in an other time
	if ($_SESSION['expire'] < date("H:i:s")) {
		$login = $_SESSION['login_cipux'];
		$_SESSSION = array();
		$_SESSION['login_cipux'] = $login;
	}
	else if (isset($_SESSION['cipux'])) {
		// set the uid and the value given by the log in method in the new instance of the class
		$cipux->set_ticket($_SESSION['login_cipux'],$_SESSION['cipux']);
	}
}

if (isset($_SESSION['cipux'])) {
	$page = 'menu.php'; // default page is the menu, to select a tool
	
	// if $_POST['page'] is set we use this page
	if (isset($_POST['page'])) {
		$page = $_POST['page'];
	}
	
	// here we call the script which manages the groups
	if (isset($_GET['page'])) {
		if ($_GET['page'] == "gm") {
			$page = "groups_manager.php";
		}
	}
		
	//finaly we include the script which is called
	include($page);
	
	// get the user firstname and lastname
	$user = $cipux->tell_me_user_canonical_name($_SESSION['login_cipux']);
	
	// edit the log file in order to know who are using cipuxPHP
	edit_log_file ($page, $user[0]);
}

// including the footer file
include ('header-footer/'.$cms.'footer.php');
?>