<?

/** ********************************************************************************************* **/
/**                                                                                               **/
/** user_creator.php                                                                              **/
/**                                                                                               **/
/** Author : Jean-Charles Siegel, jeancharles.siegel@gmail.com                                    **/
/**                                                                                               **/
/** Year : 2006                                                                                   **/
/**                                                                                               **/
/** Licence : GPLv2                                                                               **/
/**                                                                                               **/
/** Edited for : Debian Edu/Skolelinux, CipUX                                                     **/
/**                                                                                               **/
/** Description : This is the script used to create a user, who can be one of this 3 types :      **/
/**               student, teacher, guest and assistant                                           **/
/**                                                                                               **/
/** ********************************************************************************************* **/

// get the user type 
$type_user = (isset($_POST['type_user'])) ? ceil($_POST['type_user']) : 0;

// creation of a user
if (isset($_POST['submit_create'])) {
	// testing fields if they are empty then set code error
	if (empty($_POST['account'])) {
		$errno = '0';
		$empty = true;
	}
	else if (empty($_POST['name'])) {
		$errno = '1';
		$empty = true;
	}
	else if (empty($_POST['lastname'])) {
		$errno = '2';
		$empty = true;
	}
	else if (empty($_POST['password1'])) {
		$errno = '3';
		$empty = true;
	}
	else if (empty($_POST['password2'])) {
		$errno = '4';
		$empty = true;
	}
	else if ($_POST['password2']!=$_POST['password1']) {
		$errno = '5';
		$empty = true;
	}
	else {
		$empty = false;
	}	
	
	//these actions are made only if the previous fields are not empty
	if (!$empty) {
		if (isset($_POST['user_type'])) {
			switch ($_POST['user_type']) { // detection of the type of user
				case 1 :
					$usertype = "student";
					break;
				case 2 :
					$usertype = "teacher";
					break;
				case 3 :
					$usertype = "guest";
					break; 
				case 4 :
					$usertype = "assistant";
					break; 
			}
		}
		
		// creation of the user with the data
		$result1 = $cipux->create_user($_POST['account'], $_POST['name'], $_POST['lastname'], $usertype, $_POST['password1']); 
		
		if ($usertype == "guest") // if the user is a guest we add him directly in the group guest
			$result2 = $cipux->add_user_to_course('nogroup', $_POST['account']);
		else
			$result2 = $cipux->add_user_to_course($_POST['classe'], $_POST['account']);	
			
		// test if there is no problem during the creation
		if ($result1 == false) {
			$confirm = false;
		}
		else {
			$confirm = true;
		}
	}
}
?>
<table align="center" class="generalbox" border="0" cellpadding="20" cellspacing="0">
	<tr>
		<td class="generalboxcontent">
			<h3><? echo (get_string('create_user','cipuxPHP')); ?></h3>
			
				<!-- First, the selection of the type of user -->
			
				<form action="index.php" method="post">
					<input type="hidden" name="page" value="user_creator.php"/>
					<p><? echo (get_string('select_user','cipuxPHP')); ?>
					<select name="type_user">
						<option value="1"><? echo (get_string('student','cipuxPHP')); ?></option>
						<option value="2"><? echo (get_string('teacher','cipuxPHP')); ?></option>
						<option value="3"><? echo (get_string('guest','cipuxPHP')); ?></option>
						<option value="4"><? echo (get_string('assistant','cipuxPHP')); ?></option>
					</select>
					<input type="submit" name="submit" value="<? echo (get_string('valid','cipuxPHP')); ?>"/>
					</p>
				</form>

				<?// Then we look which type of user is selected and display this type
					if ($type_user) {
						switch ($type_user) {
							case 1:
								echo '<h4>'.get_string('student','cipuxPHP').'</h4>';
								break;
							case 2:
								echo '<h4>'.get_string('teacher','cipuxPHP').'</h4>';
								break;
							case 3:
								echo '<h4>'.get_string('guest','cipuxPHP').'</h4>';
								break;
							case 4:
								echo '<h4>'.get_string('assistant','cipuxPHP').'</h4>';
								break;
						}
				?>
				
				<form method="post" name="form2" action="">	
					<input type="hidden" name="user_type" value="<? echo ($type_user); ?>"/>
					<table>
					<tr>
						<td align="right"><? echo (get_string('account','cipuxPHP')); ?> : </td>
						<td><input type="text" name="account"/></td>
					</tr>
					<tr>
						<td align="right"><? echo (get_string('firstname','cipuxPHP')); ?> : </td>
						<td><input type="text" name="name"/></td>
					</tr>
					<tr>
						<td align="right"><? echo (get_string('lastname','cipuxPHP')); ?> : </td>
						<td><input type="text" name="lastname"/></td>
					</tr>
					<tr>
						<td align="right"><? echo (get_string('password','cipuxPHP')); ?> : </td>
						<td><input type="password" name="password1"/></td>
					</tr>
					<tr>
						<td align="right"><? echo (get_string('confirm_password','cipuxPHP')); ?> : </td>
						<td><input type="password" name="password2"/></td>
					</tr>
		
					<!-- Import groups' list from LDAP DB -->
					<?
					
					$result = $cipux->list_courses();
					if ($result){
						$array_length = sizeof($result);
						sort($result);
					}
					
					?>
					<tr>
						<td align="right"><? echo (get_string('class','cipuxPHP')); ?> : </td>
						<td>
							<?
							// if the user is not a guest we display the class where the user wil be add
							if ($type_user != "3") {
							?>
							<select name="classe">
								<!-- Here is the place for the groups' list-->
								<?
								
								for ($i=0 ; $i<$array_length ; $i++) {
									echo('<option value="'.$result[$i].'">'.$result[$i].'</option>');
								}
								
								?>
							</select>
							<?
							}
							else {
								// if the user is a guest, he is autamaticly add in the guest group
								echo(get_string('guest_group','cipuxPHP'));
							}
							?>
						</td>
					</tr>
					</table>
					<input type="hidden" name="page" value="user_creator.php"/>
					<p align="center"><input type="submit" name="submit_create" value="<? echo (get_string('create','cipuxPHP')); ?>"/></p>
				</form>		
			<? 
					}
			// here we display if a user is created without problem or not 
			if (isset($confirm) && $confirm) {
				echo '<p align="center"><font color="green">'.get_string('user_creation_confirm','cipuxPHP').'</font></p>';
			}
			else if (isset($confirm) && !$confirm) {
				echo '<p align="center"><font color="red">'.get_string('user_creation_error','cipuxPHP').'</font></p>';
			}
			else if (isset($errno)) {
				echo '<p align="center"><font color="red">'.get_string('error'.$errno,'cipuxPHP').'</font></p>';
			}
			include('return.php'); 
			?>
		</td>
	</tr>
</table>
