<?

/** ********************************************************************************************* **/
/**                                                                                               **/
/** menu.php                                                                                      **/
/**                                                                                               **/
/** Author : Jean-Charles Siegel, jeancharles.siegel@gmail.com                                    **/
/**                                                                                               **/
/** Year : 2006                                                                                   **/
/**                                                                                               **/
/** Licence : GPLv2                                                                               **/
/**                                                                                               **/
/** Edited for : Debian Edu/Skolelinux, CipUX                                                     **/
/**                                                                                               **/
/** Description : This script is used to manage the users teachers, guests, students              **/
/**               the modify button is only used to modify the user password, you can't change    **/
/**               the login, the firstname, or the lastname                                       **/
/**                                                                                               **/
/** Warnings : this part of script is not valid on w3c validator when you want to change the user **/
/**            password.                                                                          **/
/**            Number of errors : 3                                                               **/
/**                                                                                               **/
/** ********************************************************************************************* **/

// we list one time the classes in order to display them in a combobox and then you are able search users by classes
$result1 = $cipux->list_courses();

// make tree lists used to check the user type and also display only students, teachers or guests
$list_students = $cipux->list_students();
$list_teachers = $cipux->list_teachers();
$list_guests = $cipux->list_guests();

// Operation the delete a user
if (isset($_POST['submit_delete'])) {
	$result = $cipux->delete_user($_POST['user_id']);
	if ($result) { $msg = '<font color="green">'.get_string('delete_user_ok','cipuxPHP').'</font>'; }
	else { $msg = '<font color="red">'.get_string('delete_user_error','cipuxPHP').'</font>'; }
}

//operation to change the user password
if (isset($_POST['submit_edit2'])) {
	if (empty($_POST['password1'])) {
		$msg = '<font color="red">'.get_string('error3','cipuxPHP').'</font>';
	}
	else if (empty($_POST['password2'])) {
		$msg = '<font color="red">'.get_string('error4','cipuxPHP').'</font>';
	}
	else if ($_POST['password2'] != $_POST['password1']) {
		$msg = '<font color="red">'.get_string('error5','cipuxPHP').'</font>';
	}
	else {
		$result = $cipux->change_user_password($_POST['user_id'], $_POST['password1']);
		if ($result) { $msg = '<font color="green">'.get_string('change_user_password_ok','cipuxPHP').'</font>'; }
		else { $msg = '<font color="red">'.get_string('change_user_password_error','cipuxPHP').'</font>'; }
	}
}
?>

<table align="center" width="100%" class="generalbox" border="0" cellpadding="20" cellspacing="0">
<tr>
	<td class="generalboxcontent">
		<h3><? echo (get_string('users_manager','cipuxPHP')); ?></h3>
	
	<!-- here begin the form used to make filter on the list of users -->
	<form method="post" action="">
	<input type="hidden" name="page" value="users_manager.php"/>
	<p>
		<? echo (get_string('display_users_group','cipuxPHP')); ?>
		
		<!-- here is the option to display by classes -->
		
		<select name="display_group">
			<option></option>
			<?
			for ($i=0 ; $i<sizeof($result1) ; $i++) {
				echo ('<option value="'.$result1[$i].'">'.$result1[$i].'</option>');
			}
			?>
		</select><br />
		
		<? echo (get_string('display_account','cipuxPHP')); ?>
		
		<!-- here is the option to display by type of user -->
		
		<select name="display_account">
			<option></option>
			<option value="0"><? echo (get_string('all_account','cipuxPHP')); ?></option>
			<option value="1"><? echo (get_string('student','cipuxPHP')); ?></option>
			<option value="2"><? echo (get_string('teacher','cipuxPHP')); ?></option>
			<option value="3"><? echo (get_string('guest','cipuxPHP')); ?></option>
		</select><br />
		<? echo (get_string('display_user_by','cipuxPHP')); ?>
		
		<!-- here is the option to display users who are beginning with the letter  -->
		
		<select name="letter">
			<option></option>
			<?
			$array = $cipux->list_users_first_letter();
			for ($i=0 ; $i<sizeof($array) ; $i++) {
				echo('<option value="'.$array[$i].'">'.$array[$i].'</option>');
			}
			?>
		</select><br/>
		<? echo (get_string('sort_user_by','cipuxPHP')); ?>
		
		<!-- here is the option to sort the list -->
		
		<select name="sort">
			<option></option>
			<option value="asc"><? echo (get_string('asc','cipuxPHP')); ?></option>
			<option value="desc"><? echo (get_string('desc','cipuxPHP')); ?></option>
		</select>
		<br/><input type="submit" name="submit_display" value="<? echo (get_string('valid','cipuxPHP')); ?>"/>
	</p>
	</form>

	<p align="center"><? echo($msg); ?></p>
	
	<table class="generalbox" style="width:100%">
	<tr>
		<th class="header c1" style="text-align:left"><a href="#"><? echo (get_string('account','cipuxPHP')); ?></a></th>
		<th class="header c1" style="text-align:left"><a href="#"><? echo (get_string('firstname','cipuxPHP'). ' &amp; ' .get_string('lastname','cipuxPHP')); ?></a></th>
		<th class="header c1" style="text-align:left"><a href="#"><? echo (get_string('type','cipuxPHP')); ?></a></th>
		<th class="header c1" style="text-align:left"><a href="#"><? echo (get_string('password','cipuxPHP')); ?></a></th>
		<th class="header c1" style="text-align:left"><a href="#"><? echo (get_string('actions','cipuxPHP')); ?></a></th>
	</tr>

<?php


if (isset($_POST['display_group']) && !empty($_POST['display_group'])) {
	// here is the script that list the members of a class
	$result = $cipux->list_user_members_of_course($_POST['display_group']);
}
else if (isset($_POST['display_account']) && !empty($_POST['display_account'])) {
	switch ($_POST['display_account']) {
		case 0:
			// this script list al the users 
			$result = $cipux->list_users();
			break;
		case 1:
			// this script list only students
			$result = $list_students;
			break;
		case 2:
			// this script list only teachers
			$result = $list_teachers;
			break;
		case 3:
			// this script list only guests
			$result = $list_guests;
			break;
	}
}
else if (isset($_POST['letter'])) {
	if (!empty($_POST['letter'])) $letter = $_POST['letter'];
	else $letter = $array[0] ;
	$res = $cipux->list_users(); 
	$j = 0;
	
	// this script list the users who are beginning with the given letter
	for ($i=0 ; $i<sizeof($res) ; $i++) {
		if ($res[$i][0] == $letter) {
			$result[$j] = $res[$i];
			$j++;
		}
	}
}
else {
	// this strict is executed in all the other case and lists all the users 
	$res = $cipux->list_users(); 
	$j = 0;
	
	// this script list the users who are beginning with the given letter
	for ($i=0 ; $i<sizeof($res) ; $i++) {
		if ($res[$i][0] == $array[0]) {
			$result[$j] = $res[$i];
			$j++;
		}
	}
}

// here we sort the list by ascending or descending
if (isset($_POST['sort']) && $_POST['sort'] == "desc") {
	rsort($result);
}
else if (isset($_POST['sort']) && $_POST['sort'] == "asc"){
	sort($result);
}


for ($i=0; $i<sizeof($result); $i++)
{
	// here we get the canonical name of a user canonical name = firstname + lastname
	$name = $cipux->tell_me_user_canonical_name($result[$i]);
	// and next the role
	$role = $cipux->tell_me_user_role($result[$i]);
	
	// "Show user"
	if (!isset($_POST['submit_edit']) || $_POST['user_id'] != $result[$i]) {
		echo '
		<tr'.( ($i%2) ? ' style="background:#eee"' : '' ).'>
			<td>'.$result[$i].'</td>
			<td>'.$name[0].'</td>
			<td>'.get_string($role[0],'cipuxPHP').'</td>
			<td>*****</td>
			<td>
				<table><tr><td>
					<form action="index.php#user_selected" method="post">
						<input type="hidden" name="page" value="users_manager.php" />
						<input type="hidden" name="letter" value="'.$letter.'" />
						<input type="hidden" name="user_id" value="'.$result[$i].'" />
						<input type="submit" name="submit_edit" value="'.get_string('edit','cipuxPHP').'" />
					</form>
				</td><td>
					<form method="post" action="index.php">
						<input type="hidden" name="user_id" value="'.$result[$i].'" />
						<input type="hidden" name="letter" value="'.$letter.'" />
						<input type="hidden" name="page" value="users_manager.php" />
						<input type="submit" name="submit_delete" value="'.get_string('delete','cipuxPHP').'" onclick="javascript:return window.confirm(\''.get_string('confirm1','cipuxPHP').'\');" />
					</form>
				</td></tr></table>
			</td>
		</tr>';
	}

	// "Edit user" form
	else
	{
		echo '
		<form action="" method="post">
		<tr'.( ($i%2) ? ' style="background:#eee"' : '' ).'>
			<td><a name="user_selected"></a>'.$result[$i].'</td>
			<td>'.$name[0].'</td>
			<td>'.get_string($role[0],'cipuxPHP').'</td
			<td>
				<input type="password" name="password1" value="" />
				<input type="password" name="password2" value="" />
			</td>
			<td>
					<input type="hidden" name="page" value="users_manager.php" />
					<input type="hidden" name="user_id" value="'.$result[$i].'" />
					<input type="hidden" name="letter" value="'.$letter.'" />
					<input type="submit" name="submit_edit2" value="'.get_string('valid','cipuxPHP').'" />
					<input type="submit" name="cancel" value="'.get_string('cancel','cipuxPHP').'" onclick="javascript:histori.go(-1);" />
			</td>
		</tr>
		</form>';
	}
}

echo '</table>';


	require_once('return.php');

	echo '</td></tr></table>';

?>
