#!/usr/bin/perl -w
# +========================================================================+
# || CAT CipUX Administration Tool                                        ||
# || CAT-web module: groupadmin.cgi                                       ||
# ||                                                                      ||
# || (c) 2006 Christian Kuelker                                           ||
# || License: GPLv2 or later                                              ||
# +========================================================================+

#TODO:
# (1) Password schema should be equal, validate with java script
#    see Formbuilder
# (2) Meaningful values for password match
# (3) Group Quota support
#     - set
#     - quota view
# (4) Test for non ASCI chars in set password
# (8) internationalisierung
# (9) cipux-rpc robuster machen: wenn cipux_task_create_course($login,$ticket,$gid)
#     ohne PASSWORT, dasnn stuerzt er ab
#     Mann kann allerdings was im http-erro.log nachlesen:
#     500 Server closed connection without sending any data back
#     Es gibt keinen Error code zurueck, wenn die gruppe 2x angelegt wird.
# (10) Error code handling
#      Machmal bekommt man einen CODE, dann bitte vereinheitlichen:
#      CODE 0   (no ERROR)
#      CODE 1   (ERROR)
#      CODE 255 (ERROR)
#      Der XML-RPC Server muss seine warings nicht nur in das log schreiben sondern
#      als $XML=$server->encode_fault(...) surueckliefern
package groupadmin_cgi;

# +=======================================================================+
# ||                                                                     ||
# +=======================================================================+
use CGI::FormBuilder qw($jshead);
use lib ".";
use CipUX::CAT::Web;
use strict;

# +=======================================================================+
# ||                                                                     ||
# +=======================================================================+
# GLOBAL
our $script = 'groupadmin';
our $login   = '';
our $ticket  = '';
our $cookie1 = '';
our $cookie2 = '';
our ($path,$lang,$theme,$query,$server) = &init();

&debug("================================= start cipux cat web groupadmin  ==============");
&debug("path [$path]\nlang [$lang]\ntheme [$theme]\nquery [$query]\nserver [$server]\n");

# +=======================================================================+
# ||                                                                     ||
# +=======================================================================+

&debug("- get cookies");
$ticket=$query->cookie(-name=>'cat_session');
$login=$query->cookie(-name=>'cat_login');

&debug("- check_for_login");
($login, $ticket, $cookie1, $cookie2) = &check_for_login($login,$ticket);

&debug("- renew_session");
($login, $ticket, $cookie1, $cookie2) = &renew_session($login,$ticket);

&debug("- print cgi header");
print $query->header(-cookie=>[$cookie1,$cookie2]);

# +=======================================================================+
# ||                                                                     ||
# +=======================================================================+
# initialize forms after ticket is known

&debug("- initialize forms");
my $idx = &idx;
my $create = &create;

&debug("- print html header");
print &header;

&debug("- check for ACL access");
&check_access($login,$ticket,$script);

&debug("- print status line");
print &statusline($login,$ticket,$script);

&debug("FORM1 S [".$idx->submitted."]") if defined $idx->submitted;
&debug("FORM1 V [".$idx->validate."]") if defined $idx->validate;

# +=======================================================================+
# ||                                                                     ||
# +=======================================================================+
if ($idx->submitted && $idx->validate) {
  # SET
  if($idx->submitted eq 'set'){
    my $gid = $idx->field('gid') || exception('2-000-010-0001-001','no_uid_given');
    my $p1  = $idx->field('password') || exception('2-000-010-0002-002','no_password_given');
    my $p2  = $idx->field('password_repeat') || exception('2-000-010-0002-003','no_password_given');
    if($p1 eq $p2){
      &rpc('str','cipux_task_change_course_password',[$login,$ticket,$gid,$p1]);
    }else{
      &exception('2-000-010-0004-008','passwords_not_equal');
    } 
    print &tpl("result/change_password",{object=>$gid});
  }
  # DELETE
  if($idx->submitted eq 'delete'){
    my $gid = $idx->field('gid') || die "No group id!";
    &debug("* delete object [$gid]");
    rpc('str','cipux_task_delete_course',[$login,$ticket,$gid]);
    print &tpl("result/delete_object",{object=>$gid});
  }   
}

&debug("FORM2 S[".$create->submitted."]") if defined $create->submitted;
&debug("FORM2 V[".$create->validate."]") if defined $create->validate;

if ($create->submitted && $create->validate) {
  # CREATE
  if($create->submitted eq 'create'){
    my $id = $create->field('id') || exception('2-000-010-0003-004','no_gid_given');
    &debug("* create object [$id]");
    my $p1 = $create->field('new_password') || exception('2-000-010-0002-005','no_password_given');
    my $p2 = $create->field('new_password_repeat') || exception('2-000-010-0002-006','no_password_given');
    if($p1 eq $p2){
      &rpc('str','cipux_task_create_course',[$login,$ticket,$id,$p1]);
    }else{
      &exception('2-000-010-0004-007','passwords_not_equal');
    }
    print &tpl("result/create_object",{object=>$id});
  }
}

# +=======================================================================+
# ||                                                                     ||
# +=======================================================================+
# PRINT idx table
print &tpl("groupadmin/idx_header"); 
# why this can't be a sub call rcp?
my $group_ref = $server->call('cipux_task_list_courses',@{[$login,$ticket]});
#my $group_ref = rpc('aref','cipux_task_list_courses',@{[$login,$ticket]});
foreach my $group (sort @{$group_ref}){
  &debug( "- [$group]");
  $idx->field(name => 'gid', type =>'static', value => "$group",force=>1);
  print $idx->render();
}
print &tpl("groupadmin/idx_footer"); 

# PRINT ceate table
&debug("* print create table");
print &tpl("groupadmin/create_header"); 
print $create->render();
print &tpl("groupadmin/create_footer"); 

# +=======================================================================+
# ||                                                                     ||
# +=======================================================================+
print &footer(0);
exit(0);

# +=======================================================================+
# || local sub                                                           ||
# +=======================================================================+

# new object
sub create {
  my $create = CGI::FormBuilder->new(
             method => 'post',
             fields => [qw/id new_password new_password_repeat/],
	     validate => {
                           id => "NAME",
                           new_password => "NAME",
                           new_password_repeat => "NAME",
	                 },
             required => 'ALL',
	     submit => [qw/create/],
	     params => $query,
	     sticky =>0,
	     keepextra => 1,
	     stylesheet => "$path/$lang/$theme/form.css",
	     template => "$path/$lang/$theme/header.html",
	     template => "$path/$lang/$theme/groupadmin/create_body.html",
        );

  $create->field(name => 'new_password', type => 'password');
  $create->field(name => 'new_password_repeat', type => 'password');

  return $create;
}

# index
sub idx {
  my $idx = CGI::FormBuilder->new(
             method => 'post',
             fields => [qw/gid password password_repeat/],
	     validate => {gid => 'NAME'},
	     require  => 'gid',
             submit => [qw/set delete/],
	     params => $query,
	     keepextra => 1,
	     table => 0, 
	     reset => 0,
	     sticky =>0,
	     stylesheet => "$path/$lang/$theme/form.css",
	     template => "$path/$lang/$theme/groupadmin/idx_body.html",
        );

$idx->field(name => 'gid', type=> 'static');
$idx->field(name => 'password', type=> 'password', value=>"");
$idx->field(name => 'password_repeat', type=> 'password', value=>"");
 return $idx;
}

