#!/usr/bin/perl -w
# +========================================================================+
# || CAT CipUX Administration Tool                                        ||
# || CAT-web module: index.cgi                                        ||
# ||                                                                      ||
# || (c) 2006 Christian Kuelker                                           ||
# || License: GPLv2 or later                                              ||
# +========================================================================+
package index_cgi;

# +=======================================================================+
use CGI::FormBuilder qw($jshead);
use lib ".";
use CipUX::CAT::Web;
use strict;

# GLOBAL
our $script = 'index';
our $login   = '';
our $ticket  = '';
our $cookie1 = '';
our $cookie2 = '';
our ($path,$lang,$theme,$query,$server) = &init();

&debug("================================= start cipux cat web index  ==============");

# +=======================================================================+

$ticket=$query->cookie(-name=>'cat_session');
$login=$query->cookie(-name=>'cat_login');


($login, $ticket, $cookie1, $cookie2) = &check_for_login($login,$ticket);
($login, $ticket, $cookie1, $cookie2) = &renew_session($login,$ticket);

my $logout = &logout;
if ($logout->submitted && $logout->validate) {
  if($logout->submitted eq 'logout'){
    &do_logout($login,$ticket);
  } 
}

print $query->header(-cookie=>[$cookie1,$cookie2]);


print &header;

&check_access($login,$ticket,$script);

print &statusline($login,$ticket,$script);


my @modules = qw(
                 useradmin 
                 groupadmin 
                 tutoradmin 
);


my $row=5;
my $c=0;
print &tpl('index/idx_haeder');
foreach (@modules){
  my $name = $_;
  $name =~ s/_/ /g;
  $c++;
  if($c >= $row){
    print &tpl('index/idx_linebreak');
    $c=0;
  }
  print  &tpl('index/idx_module',{ module => "$_" , module_name => "$name"});
}
print &tpl('index/idx_footer');


print $logout->render();

print &footer(0);
exit(0);

# +=======================================================================+
# || local sub                                                           ||
# +=======================================================================+

# new object
sub logout {
  my $logout = CGI::FormBuilder->new(
             method => 'post',
	     submit => [qw/logout/],
	     params => $query,
	     sticky =>0,
	     keepextra => 1,
	     stylesheet => "$path/$lang/$theme/form.css",
	     template => "$path/$lang/$theme/logout.html",
        );

  return $logout;
}
