#!/usr/bin/perl -w
# +========================================================================+
# || CAT CipUX Administration Tool                                        ||
# || CAT-web module: tutoradmin.cgi                                        ||
# ||                                                                      ||
# || (c) 2006 Christian Kuelker                                           ||
# || License: GPLv2 or later                                              ||
# +========================================================================+
package tutoradmin_cgi;

# +=======================================================================+
use CGI::FormBuilder qw($jshead);
use lib ".";
use CipUX::CAT::Web;
use strict;

# GLOBAL
our $script = 'tutoradmin';
our $login   = '';
our $ticket  = '';
our $cookie1 = '';
our $cookie2 = '';
our ($path,$lang,$theme,$query,$server) = &init();
our $mode = 0; # 0 = overview, 1 = action

&debug("================================= start cipux cat web tutoradmin  ==============");

# +=======================================================================+

$ticket=$query->cookie(-name=>'cat_session');
$login=$query->cookie(-name=>'cat_login');

($login, $ticket, $cookie1, $cookie2) = &check_for_login($login,$ticket);
($login, $ticket, $cookie1, $cookie2) = &renew_session($login,$ticket);

print $query->header(-cookie=>[$cookie1,$cookie2]);

my $idx = &idx;

print &header;

&check_access($login,$ticket,$script);

print &statusline($login,$ticket,$script);

# +=======================================================================+
if ($idx->submitted && $idx->validate) {
  # LIST
  if($idx->submitted eq 'list'){
    &debug("  - list pushed");
    my $oid = $idx->field('oid') || exception('2-000-010-0001-001','no_gid_given');
    my $mode = 1; 
    my $group = &group($oid,$server->call('cipux_task_list_user_members_of_course',@{[$login,$ticket,$oid]}));
    print &tpl("tutoradmin/group_header"); 
    print $group->render();
    print &tpl("tutoradmin/group_footer"); 

  }
  # TAKE
  if($idx->submitted eq 'take'){
    &debug("  - take pushed");
    my $oid = $idx->field('oid') || exception('2-000-010-0001-001','no_gid_given');
    my $mode = 2; 
  }
  # REMOVE
  if($idx->submitted eq 'remove'){
    &debug("  - removed pushed");
    my $oid = $idx->field('oid') || exception('2-000-010-0001-001','no_gid_given');
    my $mode = 3; 
  }
}

if($mode == 0){
# +=======================================================================+
# PRINT idx table

print &tpl("tutoradmin/idx_header"); 
my $course_ref = $server->call('cipux_task_list_courses',@{[$login,$ticket]});
foreach my $course (sort @{$course_ref}){
  $idx->field(name => 'oid', type =>'static', value => "$course",force=>1);
  print $idx->render();
}
print &tpl("tutoradmin/idx_footer"); 
}
print &footer(0);


exit(0);

# +=======================================================================+
# || local sub                                                           ||
# +=======================================================================+

# index
sub idx {
  my $idx = CGI::FormBuilder->new(
             method => 'post',
             fields => [qw/oid/],
	     validate => {oid => 'NAME'},
	     require  => 'oid',
             submit => [qw/list take remove/],
	     params => $query,
	     keepextra => 1,
	     table => 0, 
	     reset => 0,
	     sticky =>0,
	     stylesheet => "$path/$lang/$theme/form.css",
	     template => "$path/$lang/$theme/tutoradmin/idx_body.html",
        );

$idx->field(name => 'oid', type=> 'static');
return $idx;
}

sub group {
  my $oid = shift;
  my $members_aref = shift;
  my $group = CGI::FormBuilder->new(
             method => 'post',
             fields => [qw/oid/],
             validate => {oid => 'NAME'},
             require  => 'oid',
             submit => [qw/apply/],
             params => $query,
             keepextra => 1,
             table => 0,
             reset => 0,
             sticky =>0,
             stylesheet => "$path/$lang/$theme/form.css",
             template => {
                          filename => "$path/$lang/$theme/tutoradmin/group_body.html",
                          global_vars => '2',
                          loop_context_vars => 1,
                          },

        );

$group->field(name => 'oid', type => 'static', value => "$oid", force => 1 );
$group->field(name => 'members' ,
            options => $members_aref, 
            type => 'checkbox',
            multiple => 1);
#$group->tmpl_param(allmembers=>[ {members => 'hallo', members=>'wer'}]);
#$group->tmpl_param(allmembers=>\@{$members_aref});
 return $group;
}

