#!/usr/bin/perl -w
# +========================================================================+
# || CAT CipUX Administration Tool                                        ||
# || CAT-web module: userlist.cgi                                         ||
# ||                                                                      ||
# || (c) 2006 Christian Kuelker                                           ||
# || License: GPLv2 or later                                              ||
# +========================================================================+
package userlist_cgi;

# +=======================================================================+
use CGI::FormBuilder qw($jshead);
use lib ".";
use CipUX::CAT::Web;
use strict;

# GLOBAL
our $script = 'userlist';
our $login   = '';
our $ticket  = '';
our $cookie1 = '';
our $cookie2 = '';
our ($path,$lang,$theme,$query,$server) = &init();

&debug("================================= start cipux cat web userlist  ==============");

# +=======================================================================+

$ticket=$query->cookie(-name=>'cat_session');
$login=$query->cookie(-name=>'cat_login');

($login, $ticket, $cookie1, $cookie2) = &check_for_login($login,$ticket);
($login, $ticket, $cookie1, $cookie2) = &renew_session($login,$ticket);

print $query->header(-cookie=>[$cookie1,$cookie2]);

my $idx = &idx;

print &header;

&check_access($login,$ticket,$script);

print &statusline($login,$ticket,$script);

# +=======================================================================+
# PRINT idx table
print &tpl("useradmin/idx_header"); 
my $user_ref = $server->call('cipux_task_list_users',@{[$login,$ticket]});
foreach my $user (sort @{$user_ref}){
  $idx->field(name => 'oid', type =>'static', value => "$user",force=>1);
  print $idx->render();
}
print &tpl("useradmin/idx_footer"); 

print &footer(0);
exit(0);

# +=======================================================================+
# || local sub                                                           ||
# +=======================================================================+

# index
sub idx {
  my $idx = CGI::FormBuilder->new(
             method => 'post',
             fields => [qw/oid/],
	     validate => {oid => 'NAME'},
	     require  => 'oid',
	     params => $query,
	     keepextra => 1,
	     table => 0, 
	     reset => 0,
	     sticky =>0,
	     stylesheet => "$path/$lang/$theme/form.css",
	     template => "$path/$lang/$theme/useradmin/idx_body.html",
        );

 $idx->field(name => 'oid', type=> 'static');
 return $idx;
}

