#!/usr/bin/perl -w

# script to make a html index of the man pages
# (c) 2006 by Christian Kuelker
# License: GPLv2 or later

use strict;


=pod

=head1 NAME

cipux_make_documentation_index


=head1 DECRIPTION

Write index for documentation.

=cut




my $basedir = "/usr/share/doc";
my $output  = "/tmp/index.html";
my @package = qx(ls -1 /etc/cipux/package);
my $title ="CipUX Developer Documentation Man Pages <[CipUX::VERSION]>";

my @html = ();
push(@html,"<html>\n");
push(@html,"  <head>\n");
push(@html,"    <title>$title</title>\n");
push(@html,"  </head>\n");
push(@html,"  <body>\n");
push(@html,"\n    <h1>$title</h1>\n");
foreach my $p (@package){
  chomp($p);
  if(-d "$basedir/$p/html"){
    push(@html,"\n    <h2>$p</h2>\n");
    my @doc = qx(ls -1 $basedir/$p/html);
    foreach my $d (@doc){
      chomp($d);
      push(@html,"      <a href='$p/html/$d'>$d</a>\n");
    }
  }
}
push(@html,"  </body>\n");
push(@html,"</html>");

foreach(@html){
 print $_;
}

#my $html = join('',@html);

#qx(echo "$html" > $output);

