#!/usr/bin/python
# -*- coding: iso-8859-15 -*-
"""Module docstring.
 *========================================================================*
 || cipux_migration_wlus2cipux (alpha)!!!                                          ||
 || This script tries to convert the old WLUS-Ldap-Tree to CipUX            ||
 ||                                                                                             ||
 || Copyright: (c) 2005-2006  by Georg Damm             all Rights reserved!||
 || Licence:    GPLv2 (GPL version 2 or later)                                     ||
 ||                                                                                             ||
 || Revision:  2006-10-24                                                                ||
 ||                                                                                             ||
 *========================================================================*

This programm _tries_ to convert the WLUS users
to th new CipUX structure.
Use it at your own risk!!!!!

usage: cipux_migration_wlus2cipux -f filename

where filename is obtained by

 /usr/bin/ldapsearch -x -p 389 -h localhost -ZZ -W -D \
 'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no' -b \
 'dc=skole,dc=skolelinux,dc=no' -LLL > filename

on skolelinux 2.0!!

"""

## very ugly at the current state. 
## should be improved by using the ldaptools
## and directly changing the entries.

import sys
import getopt
from time import *
import base64
import re
from string import replace

## set coding="ascii" for cipux without utf8
## set coding="utf8" for cipux with utf8 (currently not avaliable)
coding="ascii"

ldapSecurity=" -ZZ "

backup=raw_input('Is a backup of your ldap and a list of the teachers avaliable (y/n)? ')
if backup=='n':
    print "backup your LDAP first!!!"

groupPassword=raw_input('Please enter the password for the groups: ')
ldapPassword=" -y /etc/cipux/ldappassword.conf "

## a function zu get the output og a shell command
import os, popen2

def getCommandOutput(command):
     child = os.popen(command)
     data = child.read()
     err = child.close()
     if err:
          raise RuntimeError, '%s failed w/ exit code %d' % (command, err)
     return data

def recodeUmlaute(name,type='utf8'):
     if re.compile("[^0-9A-z\.\ \-]+").search(name)==None:
          return name
     else:
          if type=='utf8':	
                return ': '+replace(base64.encodestring(name),'\n','')
          else:
                name=unicode(name,'utf8')
                name=name.replace(u"\xc4","Ae")
                name=name.replace(u"\xe4","ae")
                name=name.replace(u"\xd6","Oe")
                name=name.replace(u"\xf6","oe")
                name=name.replace(u"\xdc","Ue")
                name=name.replace(u"\xfc","ue")
                name=name.replace(u"\xdf","ss")

                name=name.replace(u"\xd4","O")
                name=name.replace(u"\xf4","o")
                name=name.replace(u"\xfb","u")
                name=name.replace(u"\xdb","U")
                name=name.replace(u"\xea","e")
                name=name.replace(u"\xca","E")
                name=name.replace(u"\xee","i")
                name=name.replace(u"\xce","I")
                name=name.replace(u"\xec","i")
                name=name.replace(u"\xeb","e")
                name=name.replace(u"\xed","i")
                name=name.replace(u"\xea","e")
                name=name.replace(u"\xe9","e")
                name=name.replace(u"\xe2","a")
                return name


class WlusUser:
    def __init__(self, fullName, uid, uidNumber, gidNumber, passwd='', home='',\
                              mailMessageStore='',loginShell='/bin/false',sambaSID='',\
                              sambaPrimaryGroupSID='', sambaPwdCanChange='',\
                              sambaPwdMustChange='',sambaLMPassword='',sambaNTPassword='',\
                              sambaPasswordHistory='',sambaPwdLastSet=''):
        self.__uid=uid
        self.__uidNumber=uidNumber
        self.__gidNumber=gidNumber
        self.__passwd=passwd

        ## samba stuff:
        self.__sambaSID=sambaSID
        self.__sambaPrimaryGroupSID=sambaPrimaryGroupSID
        self.__sambaPwdCanChange=sambaPwdCanChange
        self.__sambaPwdMustChange=sambaPwdMustChange
        self.__sambaLMPassword=sambaLMPassword
        self.__sambaNTPassword=sambaNTPassword
        self.__sambaPasswordHistory=sambaPasswordHistory
        self.__sambaPwdLastSet=sambaPwdLastSet

        ## Get the role from the file teachers.txt:
        cmd='cat teachers.txt | grep '+uid+'| wc -l'
        try:
            roleNr=getCommandOutput(cmd)
        except EnvironmentError:                            
            roleNr='student' 
        if int(roleNr)==1:
            self.__role='teacher'
        else:
            self.__role='student'
        if home=='':
            self.__home='/skole/tjener/home0/'+uid
        else:
            self.__home=home
        if mailMessageStore=='':
            self.__mailMessageStore='/var/lib/maildirs/'+uid
        else:
            self.__mailMessageStore=mailMessageStore
        self.__loginShell=loginShell

## extract firstName, LastName from fullname:
        userFullNameList=fullName.split(' ')
        lName=userFullNameList[-1:][0]
        vName=' '.join(userFullNameList[:-1])
        ## check if utf8 is necessary
        self.__lastName=recodeUmlaute(lName,coding)
        self.__firstName=recodeUmlaute(vName,coding)
        self.__fullName=recodeUmlaute(fullName,coding)
        if coding != "utf8":
            self.__lastName=self.__lastName.encode(coding, 'replace')
            self.__firstName=self.__firstName.encode(coding, 'replace')
            self.__fullName=self.__fullName.encode(coding, 'replace')
 
        
        self.__displayName=self.__fullName
        gecos=recodeUmlaute(fullName,'ascii')
        self.__gecos=gecos.encode('ascii', 'replace')
    def getUid(self):
        return self.__uid
        
    def getRole(self):
        return self.__role
        
    def getUserLdif(self):
        dateNow=strftime("%Y-%m-%d",localtime())
        ldifUserFmt=""" dn: uid=%s,ou=People,dc=skole,dc=skolelinux,dc=no
objectClass: posixAccount
objectClass: top
objectClass: shadowAccount
objectClass: imapUser
objectClass: cipuxAccount
cn: %s
uid: %s
uidNumber: %s
gidNumber: %s
homeDirectory: %s
mailMessageStore: %s
loginShell: %s
userPassword:: %s
cipuxCreationDate: %s
cipuxFirstname: %s
cipuxLastname: %s
cipuxStatus: warning
cipuxRole: account
cipuxSkeletonUid: none
cipuxInternetStatus: accept
cipuxSoftQuota: 40000
cipuxHardQuota: 50000
gecos: %s
cipuxRemark: created by CipUX::Migration (python)

""" % (self.__uid,self.__fullName,self.__uid,self.__uidNumber,\
        self.__gidNumber,self.__home,self.__mailMessageStore,\
        self.__loginShell,self.__passwd, dateNow, self.__firstName,\
        self.__lastName,self.__gecos)
        
## TODO: check sambaSID
        ldifUserFmt=""" dn: uid=%s,ou=People,dc=skole,dc=skolelinux,dc=no
objectClass: posixAccount
objectClass: top
objectClass: shadowAccount
objectClass: imapUser
objectClass: cipuxAccount
objectClass: sambaSamAccount
cn: %s
uid: %s
uidNumber: %s
gidNumber: %s
homeDirectory: %s
mailMessageStore: %s
loginShell: %s
userPassword:: %s
cipuxCreationDate: %s
cipuxFirstname: %s
cipuxLastname: %s
cipuxStatus: warning
cipuxRole: account
cipuxSkeletonUid: none
cipuxInternetStatus: accept
cipuxSoftQuota: 40000
cipuxHardQuota: 50000
gecos: %s
cipuxRemark: created by CipUX::Migration (python)
sambaSID: %s
sambaPrimaryGroupSID: %s
displayName: %s
sambaPwdCanChange: %s
sambaPwdMustChange: %s
sambaLMPassword: %s
sambaNTPassword: %s
sambaPasswordHistory: %s
sambaPwdLastSet: %s
sambaAcctFlags: [U             ]

""" % (self.__uid,self.__fullName,self.__uid,self.__uidNumber,\
        self.__gidNumber,self.__home,self.__mailMessageStore,\
        self.__loginShell,self.__passwd, dateNow, self.__firstName,\
        self.__lastName,self.__gecos,self.__sambaSID, \
        self.__sambaPrimaryGroupSID, self.__displayName,self.__sambaPwdCanChange,\
        self.__sambaPwdMustChange,self.__sambaLMPassword,self.__sambaNTPassword,\
        self.__sambaPasswordHistory,self.__sambaPwdLastSet)

        ##    utf8 characters need special care

        ldifUserFmt=replace(ldifUserFmt,': :','::')
        return ldifUserFmt
        
    def getGroupLdif(self):
        dateNow=strftime("%Y-%m-%d",localtime())
        ## samba makes no difference
        ldifUserFmt="""dn: cn=%s,ou=Group,dc=skole,dc=skolelinux,dc=no
objectClass: posixGroup
objectClass: top
objectClass: lisGroup
objectClass: cipuxGroup
cn: %s
gidNumber: %s
groupType: private
memberUid: %s
userPassword:: e5NyeXB0fWVuQm1ROEEzMjE1N1E=
description: %s
cipuxSoftQuota: 0
cipuxHardQuota: 0
cipuxRole: %s
cipuxInternetStatus: accept
cipuxCreationDate: %s
cipuxGroupLeaderUid: root
cipuxRemark: created by CipUX::Migration (python)

""" % (self.__uid,self.__uid,self.__gidNumber,self.__uid,\
        self.__uid,self.__role,dateNow)
##    utf8 characters need special care
        ldifUserFmt=replace(ldifUserFmt,': :','::')
        return ldifUserFmt
    def getLdif(self):
        return self.getUserLdif+getGroupLdif
        
    def updateLdap(self):
        ## delete old user and user private group
        cmd1=(' /usr/bin/ldapdelete  -x -p 389 -h localhost'+ldapSecurity+' -w %s -D \'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no\' "uid=%s,ou=People,dc=skole,dc=skolelinux,dc=no"')%(ldapPassword, self.getUid())
        cmd2=(' /usr/bin/ldapdelete  -x -p 389 -h localhost'+ldapSecurity+' -w %s -D \'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no\' "cn=%s,ou=Group,dc=skole,dc=skolelinux,dc=no"')%(ldapPassword, self.getUid())
        cmd3=('echo "%s" | /usr/bin/ldapadd -c -x -p 389 -h localhost'+ldapSecurity+' -w %s -D \'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no\' ')%(self.getUserLdif(),ldapPassword)
        cmd4=('echo "%s" | /usr/bin/ldapadd -c -x -p 389 -h localhost'+ldapSecurity+' -w %s -D \'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no\' ')%(self.getGroupLdif(),ldapPassword)
        cmd5=('/usr/bin/cipux_task_add_user_to_course "%s" "%s"')%(self.getRole(),self.getUid())

        print 'delete user: ', self.getUid()
        print getCommandOutput(cmd1)
        print getCommandOutput(cmd2)
        print 'deleted user: ', self.getUid()
        ## add new user and his private group
        print 'add user: ', self.getUid()
        print getCommandOutput(cmd3)
        print getCommandOutput(cmd4)
        print 'added user: ', self.getUid()
        

class WlusGroup:
    def __init__(self, name, gidNumber, members=[]):
        self.__name=name
        self.__gidNumber=gidNumber
        self.__members=members
 
    def getGroupName(self):
        return self.__name

    def getMembers(self):
        print self.__members
        return self.__members
        
    def updateLdap(self):
        cmd1=('/usr/bin/ldapdelete  -x -p 389 -h localhost'+ldapSecurity+' -w %s -D \'cn=admin,ou=People,dc=skole,dc=skolelinux,dc=no\' "cn=%s,ou=Group,dc=skole,dc=skolelinux,dc=no"')%(ldapPassword, self.getGroupName())
        cmd2='cipux_task_create_course '+self.__name+' '+groupPassword
        print 'delete old group: ', self.getGroupName()
        print getCommandOutput(cmd1)
        print 'create new group: ', self.getGroupName()
        print getCommandOutput(cmd2)
        print 'finished creating new group: ', self.getGroupName()
        print 'adding old users to the group'
        for member in self.getMembers():
            cmd3='cipux_task_add_user_to_course '+self.__name+' '+member
            print getCommandOutput(cmd3)
        print 'group complete'
                

def checkLeafType(leaf):
## user: dn: uid=test,ou=People,dc=skole,dc=skolelinux,dc=no
## group: dn: cn=k05a,ou=Group,dc=skole,dc=skolelinux,dc=no
## none: der Rest!!!
    knot=leaf[0]
    cipuxLeaf='False'
    for line in leaf:
        if line.find('cipux')>=1:
            cipuxLeaf='True'
    if knot[:8]=='dn: uid=' and knot.find('ou=People,dc=skole,dc=skolelinux,dc=no')>0:
        name=knot[knot.find('=')+1:knot.find(',')]
        if name=='root':
            type='unknown'
        elif cipuxLeaf=='True' or name=='admin':
            type='userCipux'
        else:
            type='userWlus'

    elif  knot.find('ou=Group,dc=skole,dc=skolelinux,dc=no')>0:
        name=knot[knot.find('=')+1:knot.find(',')]
        if cipuxLeaf=='True':
            type='groupCipux'
        elif leaf.count('groupType: school_class\n')>=1:
            type='groupWlus'
        elif leaf.count('groupType: private\n')>=1 and leaf.count('description: dontcare\n')>=1:
            type='groupWlusPrivate'
        else:
            type='group'
    else:
        name='unknown'
        type='unknown'
    print knot, name , type
    return name,type

def updateLeaf(leaf):
    leafName,leafType=checkLeafType(leaf)
    newLeaf=['']
    userSambaSID='none'
    userSambaPasswordHistory='0000000000000000000000000000000000\
0000000000000000000000'
    if leafType=='userWlus':
    ## Get full user name, extract Firstname, Lastname
        userUid=leafName
        for line in leaf:
            ## check for Full name of the User:
            if line.find('cn: ')==0:
                userFullName=line[4:-1]
            if line.find('cn:: ')==0:
                userFullName=base64.decodestring(line[5:-1])
                
            ## check for UidNumber of the User:
            if line.find('uidNumber: ')==0:
                userUidNumber=line[11:-1]
            ## check for UidNumber of the User:
            if line.find('gidNumber: ')==0:
                userGidNumber=line[11:-1]

            ## check for password-hash of the User:
            item='userPassword:: '
            if line.find(item)==0:
                userPassword=line[len(item):-1]

            ## check for home directory of the User:
            item='homeDirectory: '
            if line.find(item)==0:
                userHome=line[len(item):-1]

            ## check for mail message store of the User:
            item='mailMessageStore: '
            if line.find(item)==0:
                userMailMessageStore=line[len(item):-1]

            ## check for login shell of the User:
            item='loginShell: '
            if line.find(item)==0:
                userLoginShell=line[len(item):-1]
                
            ## check for samba stuff of the User:
            item='sambaSID: '
            if line.find(item)==0:
                userSambaSID=line[len(item):-1]
            item='sambaPrimaryGroupSID: '
            if line.find(item)==0:
                userSambaPrimaryGroupSID=line[len(item):-1]
            item='sambaPwdMustChange: '
            if line.find(item)==0:
                userSambaPwdMustChange=line[len(item):-1]
            item='sambaPwdCanChange: '
            if line.find(item)==0:
                userSambaPwdCanChange=line[len(item):-1]
            item='sambaLMPassword: '
            if line.find(item)==0:
                userSambaLMPassword=line[len(item):-1]
            item='sambaNTPassword: '
            if line.find(item)==0:
                userSambaNTPassword=line[len(item):-1]
            item='sambaPwdLastSet: '
            if line.find(item)==0:
                userSambaPwdLastSet=line[len(item):-1]
            item='sambaPasswordHistory: '
            if line.find(item)==0:
                userSambaPasswordHistory=line[len(item):-1]

        ## add objectClass: cipuxGroup
        if userSambaSID=='none':
            newWlusUser=WlusUser(fullName=userFullName, \
                                                uid=userUid, \
                                                uidNumber=userUidNumber, \
                                                gidNumber=userGidNumber, \
                                                passwd=userPassword, \
                                                home=userHome, \
                                                mailMessageStore=userMailMessageStore, \
                                                loginShell=userLoginShell)
        else:
            newWlusUser=WlusUser(fullName=userFullName, \
                                                uid=userUid, \
                                                uidNumber=userUidNumber, \
                                                gidNumber=userGidNumber, \
                                                passwd=userPassword, \
                                                home=userHome, \
                                                mailMessageStore=userMailMessageStore, \
                                                loginShell=userLoginShell, \
                                                sambaSID=userSambaSID,\
                                                sambaPrimaryGroupSID=userSambaPrimaryGroupSID,  \
				     sambaPwdCanChange=userSambaPwdCanChange,\
                                                sambaPwdMustChange=userSambaPwdMustChange,\
				     sambaLMPassword=userSambaLMPassword,\
				     sambaNTPassword=userSambaNTPassword,\
                                                sambaPasswordHistory=userSambaPasswordHistory,\
				     sambaPwdLastSet=userSambaPwdLastSet)

        newWlusUser.updateLdap()
        
    elif leafType=='groupWlusPrivate':
        pass
    elif leafType=='groupWlus':
        ## Get group name
        groupId=leafName
        groupMembers=[]
        for line in leaf:
            ## check for  of the group:
            item='gidNumber: '
            if line.find(item)==0:
                groupNumber=line[len(item):-1]
            ## check for  of the group:
            item='memberUid: '
            if line.find(item)==0:
                groupMembers.append(line[len(item):-1])
        newWlusGroup=WlusGroup(name=groupId, gidNumber=groupNumber, members=groupMembers)
        newWlusGroup.updateLdap()                
    else:
        newLeaf=leaf
    return newLeaf
        


def main():
    fileWlus=open('ldap_wlus.ldif','r')
    # parse command line options
    try:
        opts, args = getopt.getopt(sys.argv[1:], "hf:", ["help"])
    except getopt.error, msg:
        print msg
        print "for help use --help"
        sys.exit(2)
    # process options
    for o, a in opts:
        if o in ("-h", "--help"):
            print __doc__
            sys.exit(0)
        if o=='-f':
                fileWlus=open(a,'r')

    try:
        fileWlus
    except:
        print __doc__
        sys.exit(2)

    wlusContent=fileWlus.readlines()
    wlusLeafs=[]
    leaf=[]
    for line in wlusContent:
        leaf.append(line)
        if line=='\n':
            wlusLeafs.append(leaf)
            leaf=[]
    
    cipuxContent=[]
    
    for leaf in wlusLeafs:
        newLeaf=updateLeaf(leaf)
        cipuxContent.extend(newLeaf)
    
    fileWlus.close()

if __name__ == "__main__":
     main()

