# +=======================================================================+
# || /etc/cipux/dhcpd/dhcpd.conf                                         ||
# || (auto generated from dhcpd.tpl, by dhcpd_bot.pl)                    ||
# ||                                                                     ||
# ||                                                                     ||
# || (c) Copyright 2002. 2003 by Christian Kuelker                       ||
# || License: GPLv2                                                      ||
# ||                                                                     ||
# ||                                                                     ||
# +=======================================================================+
ddns-update-style none;
ignore client-updates;
# this we need for the pxegrub config file option
option bootmenu code 150 = string;
# use with dhcpd_bot.pl -t -a -n flag
# comment this out with -c -s flag
use-host-decl-names on;
# we are secure
deny unknown-clients;
# we are admins, so we know what we are doing
authoritative;

#
# This is from Debian-Edu
#

#
# Debian Edu configuration masterfile
#
# Contents of this file should be in
#
#               /etc/dhcp3/dhcpd.conf
#
#
# DHCP configuration for Debian Edu server 
#
# $Id: dhcpd.tpl 154 2006-06-21 14:01:43Z christian-guest $

# New option necessary for dhcp3
ddns-update-style         none;
option option-128 code 128 = string;
option option-129 code 129 = text;

shared-network INTERNAL {

  default-lease-time 1800; #30 m 
  max-lease-time     3600; #1 h

  option subnet-mask            255.255.254.0;
  option broadcast-address      10.0.3.255;
  option routers                gateway;
  option domain-name-servers    tjener;
  option domain-name            "intern";
  option ntp-servers            ntp;

  # Log to the main server
  option log-servers            tjener;

#  If you use window clients, comment out the following lines.
#  Samba wins support has to be turned on (wins support = yes)
#
#  # WINS server
#  option netbios-name-servers	tjener;
#  option netbios-node-type		8;


  #Automatic assigning addresses to workstations
  #There is room for approxmatly 400 workstations.

  subnet 10.0.2.0 netmask 255.255.254.0 {
     range 10.0.2.100 10.0.3.242;
  }
    
  # Group defines thinclientservers
  # Add the hardware address to the thinclientserver here
  # To add an other thinclientserver, use "host ltspserver00" as an example
  # fixed address area for thin client servers is 10.0.2.10 to 10.0.2.29

  group {
    host ltspserver00 {
       hardware ethernet 00:00:00:00:00:00;
       fixed-address ltspserver00;
    }
    # 10 printers are defined as printer00 to printer09 on 10.0.2.30-39 
    # Provide a static address using dhcp by adding their MAC addresses here
    # 10 printere er definert som printer00 til printer09 p adressene
    # 10.0.2.30-39. Gi printerne en statisk adresse ved  legge til deres
    # MAC-adresse her
    
    host printer00 {
       hardware ethernet 00:00:00:00:00:00;
       fixed-address printer00;
    }

    host printer01 {
       hardware ethernet 00:00:00:00:00:00;
       fixed-address printer01;
    }
    # 50 workstations are defined as static00 to static49 on 10.0.2.50-99 
    # Provide a static address using dhcp by adding their MAC addresses here
    # 50 arbeidsstasjoner er definert som static00 til static49 p adressene
    # 10.0.2.50-99. Gi Arbeidsstasjoner en statisk adresse ved  legge til
    # deres MAC-adresse her
    
    host static00 {
       hardware ethernet 00:00:00:00:00:00;
       fixed-address static00;
    }
    host static01 {
       hardware ethernet 00:00:00:00:00:00;
       fixed-address static01;
    }
    host static02 {
       hardware ethernet 00:00:00:00:00:00;
       fixed-address static02;
    }
    host static03 {
       hardware ethernet 00:00:00:00:00:00;
       fixed-address static03;
    }
  }
}
#
# Husk for standard tynnklienttjener for Debian Edu
# skal dhcpd kjre bare p det indre nettverkskortet
# som skal hete eth1.
#
# Don't forget to set run_dhcpd=1 in /etc/init.d/dhcpd
#
shared-network THINCLIENTS {
  default-lease-time            432000;    # 5 d
  max-lease-time                432000;    # 5 d

  option subnet-mask            255.255.255.0;
  option broadcast-address      192.168.0.255;
  option routers                ltspserver;
  option domain-name-servers    tjener;
  option domain-name            "intern";
  option root-path              "192.168.0.254:/opt/ltsp/i386";

  option ntp-servers            ntp;

  # Log to the LTSP server, and let it forward the messages.
  option log-servers            ltspserver;

  # Added if-then statement, fixes sl bug #421
  if substring (option vendor-class-identifier, 0, 9) = "PXEClient" {
    filename              "/tftpboot/lts/pxelinux.0";
  } else if substring (option vendor-class-identifier, 0, 9) = "Etherboot" {
    filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
  }

  # Use the lines below if *all* the thin clients have ISA network cards
  #option option-128     e4:45:74:68:00:00;
  #option option-129     "NIC=3c509";

  subnet 192.168.0.0 netmask 255.255.255.0 {
     # At least some thin clients will work out of the box, appearing as
     # ltsp200 to ltsp253.
     # We still recommend defining fixed mac adress to ip adress mappings,
     # cf. examples and explanations below.
     range 192.168.0.200 192.168.0.253 ;
  }

  group {
    use-host-decl-names       on;
    option log-servers        ltspserver ;

##################################################################################
#
# We recommend defining fixed mac adress (a.k.a. hardware ethernet adress) to
# ip adress mappings.
#
# Here are a number of examples applicable in different situations.
# In all cases you should fill in the hardware ethernet adress.
# The rest of the entries will vary according to the Network Interface Card (NIC)
# of the thin client: PCI or ISA based NIC. PCI NIC with or without PXE support.
#
#---------------------------------------------------------------------------------
#
# Appearance of entries inteded for actual use.
#
# You will find these entries below this example section, with the XX
# entries substituted with numbers in the range 10-99.
#
#     host ltspXXX {
#         hardware ethernet     00:00:00:00:00:00;
#         fixed-address         192.168.0.XXX;
#         filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
#         #filename              "/tftpboot/lts/pxelinux.0";
#         #option option-128     e4:45:74:68:00:00;
#         #option option-129     "NIC=3c509";
#     }
#
#  The intent is maximum ease of use/minimal editing, when defining new thin clients.
#  As an example, the entry for a thin client with a PCI based NIC, boot from
#  floppy, need only have its hardware ethernet adress filled in (and commented
#  lines can remain without adverse effect).
#
#---------------------------------------------------------------------------------
#
# Example 1: PCI based NIC, floppy based boot.
#            Replace the all-zeros hardware ethernet adress with that of the NIC
#            An appropriate boot floppy must be fetched from
#            http://rom-o-matic.com/
#
#     host ltspXXX {
#         hardware ethernet     00:00:00:00:00:00;
#         fixed-address         192.168.0.XXX;
#         filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
#     }
#---------------------------------------------------------------------------------
#
# Example 2: PCI based NIC, boot from NIC with PXE support.
#            Replace the all-zeros hardware ethernet adress with that of the NIC
#
#     host ltspXXX {
#         hardware ethernet     00:00:00:00:00:00;
#         fixed-address         192.168.0.XXX;
#         filename              "/tftpboot/lts/pxelinux.0";
#     }
#---------------------------------------------------------------------------------
#
# Example 3: ISA based NIC, floppy based boot.
#            Replace the all-zeros hardware ethernet adress with that of the NIC
#            Enable (uncomment) the option-128 and option-129 lines
#            Do NOT change option-128 in any other way.
#            Replace NIC module name with other NIC module if NIC other than 3c509
#            Fetch an appropriate boot floppy from
#            http://rom-o-matic.com/
#
#     host ltspXXX {
#         hardware ethernet     00:00:00:00:00:00;
#         fixed-address         192.168.0.XXX;
#         filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
#         option option-128     e4:45:74:68:00:00;
#         option option-129     "NIC=3c509";
#     }
#---------------------------------------------------------------------------------
#
# Example 4: ISA based NIC, floppy based boot, Linux Progress Patch (lpp)
#            As previous example, but with nice looking display of Tux and progress
#            indicator during boot.
#
#            CURRENTLY NOT DISTRIBUTED WITH Debian-edu!
#
#     host ltspXXX {
#         hardware ethernet     00:00:00:00:00:00;
#         fixed-address         192.168.0.XXX;
#         filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-lpp1";
#         option option-128     e4:45:74:68:00:00;
#         option option-129     "NIC=3c509";
#     }
##################################################################################
#
# Entries for actual use (ltsp010 to ltsp099) below:
#
# NOTE: After editing entries below, dhcpd MUST BE RESTARTED by the below
#       commands and THE THIN CLIENT IN QUESTION BE REBOOTED for changes
#       to take effect:
#
# /etc/init.d/dhcp3-server stop; /etc/init.d/dhcp3-server start
#
#
    host ltsp010 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp010;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp011 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp011;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp012 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp012;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp013 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp013;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp014 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp014;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp015 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp015;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp016 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp016;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp017 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp017;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp018 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp018;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp019 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp019;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp020 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp020;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp021 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp021;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp022 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp022;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp023 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp023;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp024 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp024;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp025 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp025;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp026 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp026;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp027 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp027;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp028 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp028;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp029 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp029;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp030 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp030;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp031 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp031;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp032 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp032;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp033 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp033;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp034 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp034;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp035 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp035;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp036 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp036;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp037 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp037;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp038 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp038;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp039 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp039;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp040 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp040;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp041 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp041;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp042 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp042;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp043 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp043;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp044 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp044;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp045 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp045;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp046 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp046;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp047 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp047;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp048 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp048;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp049 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp049;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp050 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp050;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp051 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp051;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp052 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp052;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp053 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp053;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp054 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp054;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp055 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp055;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp056 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp056;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp057 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp057;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp058 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp058;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp059 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp059;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp060 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp060;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp061 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp061;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp062 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp062;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp063 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp063;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp064 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp064;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp065 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp065;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp066 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp066;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp067 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp067;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp068 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp068;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp069 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp069;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp070 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp070;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp071 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp071;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp072 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp072;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp073 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp073;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp074 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp074;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp075 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp075;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp076 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp076;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp077 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp077;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp078 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp078;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp079 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp079;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp080 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp080;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp081 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp081;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp082 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp082;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp083 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp083;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp084 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp084;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp085 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp085;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp086 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp086;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp087 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp087;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp088 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp088;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp089 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp089;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp090 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp090;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp091 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp091;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp092 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp092;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp093 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp093;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp094 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp094;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp095 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp095;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp096 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp096;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp097 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp097;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp098 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp098;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
    host ltsp099 {
        hardware ethernet     00:00:00:00:00:00;
        fixed-address         ltsp099;
        #filename              "/tftpboot/lts/vmlinuz-2.4.19-ltsp-1";
        filename              "/tftpboot/lts/pxelinux.0";
        #option option-128     e4:45:74:68:00:00;
        #option option-129     "NIC=3c509";
    }
  }
}
