#!/bin/bash
# +==============================================================+
# || Markus Klappenbach						||
# || Thu Apr 10 14:44:44 CEST 2003				||
# || Thu Jul 17 15:58:24 CEST 2003				||
# || License: GPL						||
# +==============================================================+
# init_client ( aka 2.sh )
# runlevel 2 for yield.sh
# Sourcing Config Files
. /etc/pxes.conf
. /tmp/pxes.conf
. /tmp/${PXES_CLIENT_NAME}.conf 2>&1 >/dev/null
CREATEDATE="`date`"
DIALOG=${DIALOG=dialog}
export DIALOGRC=/etc/dialogrc_init
backtitle="Setup Image [ CipWorX CipUX Version 2.0 << www.cipworx.org >> ]"
tempfile=`tempfile 2>/dev/null` || tempfile=/tmp/test$$
trap "rm -f $tempfile" 0 1 2 5 15
touch /tmp/tmp1.$$
DSIZE=$(sfdisk -s /dev/hda) # blocks
MDSIZE=$(awk 'BEGIN { x='$DSIZE'; y='1024'; print x/y; }' | cut -d. -f1)

#if [ "$MDSIZE" -lt "8192" ]; then
if [ "$MDSIZE" -lt "4124" ]; then
	echo "
	Die Festplattengre [ "$MDSIZE" Megabyte ] dieses Systems ist 
	fr die Imageerstellung nicht ausreichend 
	Die Mindestgre betrgt 4124 Megabyte." >/tmp/text.msg
        $DIALOG --clear --exit-label "Reboot" --backtitle "$backtitle" --title "Fehler" --no-shadow --textbox "/tmp/text.msg" 15 70
                case $? in 0) clear init a exit 0 ;; 255) echo "ESC pressed.";; esac
fi


# +==============================================================+
# Configuration for dynamic Partition Modus 0
# Config: set the values for each partition in percent
PARTSIZE_1_PERCENT=30 # first partition OS
PARTSIZE_2_PERCENT=55 # second partition Image Cache
PARTSIZE_3_PERCENT=15 # third partition e.g HDGuard
# *==============================================================+

if [ "$CIPUX_PARTITION_MODUS" == "0" ]; then
	export  FSTYPE_PARTITION_1=fat32
	export	FSTYPE_PARTITION_2=ext2
	export	FSTYPE_PARTITION_3=ext2
	export	PARTSIZE_1=$(awk 'BEGIN { x='$MDSIZE'; y='$PARTSIZE_1_PERCENT'; print x*y/100; }')
	export	PARTSIZE_2=$(awk 'BEGIN { x='$MDSIZE'; y='$PARTSIZE_2_PERCENT'; print x*y/100; }')
	export	PARTSIZE_3=$(awk 'BEGIN { x='$MDSIZE'; y='$PARTSIZE_3_PERCENT'; print x*y/100; }')
	export	PARTITION_COUNT=3
	elif [ "$CIPUX_PARTITION_MODUS" == "1" ]; then
	export	FSTYPE_PARTITION_1=fat16
	export	FSTYPE_PARTITION_2=ext2
	export	FSTYPE_PARTITION_3=ext2
	export  PARTSIZE_1=2000
	export  PARTSIZE_2=$(awk 'BEGIN { x='$MDSIZE'; y='$PARTSIZE_1'; print x-y; }')
	export  PARTSIZE_3=0
	export	PARTITION_COUNT=2
	elif [ "$CIPUX_PARTITION_MODUS" == "2" ]; then
        export  FSTYPE_PARTITION_1=fat32
	export	FSTYPE_PARTITION_2=ext2
	export	FSTYPE_PARTITION_3=ext2
        export  PARTSIZE_1=3805
        export  PARTSIZE_2=3805
        export  PARTSIZE_3=495
	export	PARTITION_COUNT=3
        elif [ "$CIPUX_PARTITION_MODUS" == "3" ]; then
        export  FSTYPE_PARTITION_1=fat32
        export  FSTYPE_PARTITION_2=ext2
        export  FSTYPE_PARTITION_3=ext2
        export  PARTSIZE_1=2500
        export  PARTSIZE_2=$(awk 'BEGIN { x='$MDSIZE'; y='$PARTSIZE_1'; print x-y; }')
        export  PARTITION_COUNT=2

fi

# +==============================================================================================+
# nothing should be changed beyond this line

PARTED_END_SECOND_PARTITION=$(awk 'BEGIN { x='$PARTSIZE_1'; y='$PARTSIZE_2'; print x+y; }')
PARTED_END_THIRD_PARTITION=$(awk 'BEGIN { x='$PARTSIZE_1'; y='$PARTSIZE_2'; z='$PARTSIZE_3'; print x+y+z; }')
#PARTED_END_THIRD_PARTITION=$MDSIZE
export PARTITION1_SIZE=$(parted --script /dev/hda print 1 |grep -v grep |grep "Size" | awk -- '/Size/ {print $2}' |cut -d. -f1)
export PARTITION2_TYPE=$(parted --script /dev/hda print 2 |grep -v grep |grep "File System" | awk -- '/File System/ {print $3}')
export PARTITION2_SIZE=$(parted --script /dev/hda print 2 |grep -v grep |grep "Size" | awk -- '/Size/ {print $2}' |cut -d. -f1)

# Main function create partitions [ mkpart ]
# +==============================================================================================+
function mkpart {
	MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
        $DIALOG --backtitle "$backtitle" --title "Partitionen werden angelegt, bitte warten..." --no-kill --no-shadow \
                --tailboxbg /tmp/tmp1.$$ 15 70 2>$tempfile
        echo "" >>/tmp/tmp1.$$ 2>&1; echo -n "Lsche alte Partitionen..." >>/tmp/tmp1.$$ 2>&1
        parted --script /dev/hda rm 1 2>&1 >/dev/null
        parted --script /dev/hda rm 2 2>&1 >/dev/null
        parted --script /dev/hda rm 3 2>&1 >/dev/null
        parted --script /dev/hda rm 4 2>&1 >/dev/null
        parted --script /dev/hda rm 5 2>&1 >/dev/null
        parted --script /dev/hda rm 6 2>&1 >/dev/null
        parted --script /dev/hda rm 7 2>&1 >/dev/null
        parted --script /dev/hda rm 8 2>&1 >/dev/null
        parted --script /dev/hda rm 9 2>&1 >/dev/null
        parted --script /dev/hda rm 10 2>&1 >/dev/null
        parted --script /dev/hda rm 11 2>&1 >/dev/null
        parted --script /dev/hda rm 12 2>&1 >/dev/null
        parted --script /dev/hda rm 13 2>&1 >/dev/null
        parted --script /dev/hda rm 14 2>&1 >/dev/null
        parted --script /dev/hda rm 15 2>&1 >/dev/null
        echo "fertig" >>/tmp/tmp1.$$ 2>&1; echo -n "Partitionen werden angelegt..." >>/tmp/tmp1.$$ 2>&1
        parted --script /dev/hda mkpart primary $FSTYPE_PARTITION_1 0 $PARTSIZE_1 >>/tmp/tmp1.$$ 2>&1
        parted --script /dev/hda mkfs 1 $FSTYPE_PARTITION_1 >>/tmp/tmp1.$$ 2>&1
        parted --script /dev/hda mkpartfs primary $FSTYPE_PARTITION_2 $PARTSIZE_1 $PARTED_END_SECOND_PARTITION >>/tmp/tmp1.$$ 2>&1
	if [ "$PARTITION_COUNT" == "3" ]; then
	parted --script /dev/hda mkpartfs primary $FSTYPE_PARTITION_3 $PARTED_END_SECOND_PARTITION $PARTED_END_THIRD_PARTITION >>/tmp/tmp1.$$ 2>&1; fi
        echo "fertig" >>/tmp/tmp1.$$ 2>&1
        #parted --script /dev/hda set 1 boot on
        echo "Partitionstabelle:" >>/tmp/tmp1.$$ 2>&1
        parted --script /dev/hda print >>/tmp/tmp1.$$ 2>&1
	MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ;  mount -t ext2 /dev/hda2 /mnt/hda2; fi
        cd / && touch /mnt/hda2/.initstatus && echo "initdate: $CREATEDATE" >>/tmp/tmp1.$$ 2>&1 >/mnt/hda2/.initstatus
        echo "" >>/tmp/tmp1.$$ 2>&1; echo "Partitionierung erfolgreich, System Neustart..." >>/tmp/tmp1.$$ 2>&1
        sleep 3; clear; killall dialog
	MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
}
# +==============================================================================================+

# END create function [ mkpart ]
# +==============================================================================================+


# Syslog
# +==============================================================================================+
function debug {
	MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ;  mount -t ext2 /dev/hda2 /mnt/hda2; fi
        echo "Blocks: $DSIZE" 2>&1 >/mnt/hda2/2.sh.log
        echo "Disk Size: $MDSIZE MB" 2>&1 >>/mnt/hda2/2.sh.log
        echo "Partition 1: $PARTSIZE_1 MB; Partition 2: $PARTSIZE_2 MB; Partition 3: $PARTSIZE_3 MB" 2>&1 >>/mnt/hda2/2.sh.log
        echo "END Value second partition: $PARTED_END_SECOND_PARTITION" 2>&1 >>/mnt/hda2/2.sh.log
        echo "END Value third partition: $PARTED_END_THIRD_PARTITION" 2>&1 >>/mnt/hda2/2.sh.log
        echo "PARTITION1_SIZE: $PARTITION1_SIZE" 2>&1 >>/mnt/hda2/2.sh.log
        echo "PARTITION2_TYPE: $PARTITION2_TYPE" 2>&1 >>/mnt/hda2/2.sh.log
        echo "PARTITION2_SIZE: $PARTITION2_SIZE" 2>&1 >>/mnt/hda2/2.sh.log
        echo "FSTYPE_PARTITION_1: $FSTYPE_PARTITION_1" 2>&1 >>/mnt/hda2/2.sh.log
        echo "FSTYPE_PARTITION_2: $FSTYPE_PARTITION_2" 2>&1 >>/mnt/hda2/2.sh.log
        echo "FSTYPE_PARTITION_3: $FSTYPE_PARTITION_3" 2>&1 >>/mnt/hda2/2.sh.log
	MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
}
# +==============================================================================================+

	if [ "$PARTITION2_TYPE" == "ext2" ] && [ "$PARTITION2_SIZE" -gt "900" ]; then
	$DIALOG --title "Setup Partitions Information" --backtitle "$backtitle" --cr-wrap --nocancel --tab-correct --no-collapse --no-shadow --yesno "\

	Partitionsdaten:
	=================================================================
	Wollen Sie die Partitionen mit den folgenden Werten beibehalten ?

	$(parted --script /dev/hda print |grep "Disk")
	$(parted --script /dev/hda print |grep "primary")" 15 70

	case $? in
  	0)
		MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ;  mount -t ext2 /dev/hda2 /mnt/hda2; fi
	$DIALOG --backtitle "$backtitle" --title "Setup Partitions Information" --no-kill --no-shadow --tailboxbg /tmp/tmp1.$$ 15 70 2>$tempfile
        	echo "" >>/tmp/tmp1.$$ 2>&1
		echo -n "Erstelle Signatur fr existierende Partitionierung..." >>/tmp/tmp1.$$ 2>&1
		touch /mnt/hda2/.initstatus && echo "initdate: $CREATEDATE" >/mnt/hda2/.initstatus 2>&1
		echo "fertig" >>/tmp/tmp1.$$ 2>&1
		echo "`cat /mnt/hda2/.initstatus`" >>/tmp/tmp1.$$ 2>&1
		sleep 3
		MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
		debug
		if [ "$EXEC_SCRIPT" != "" ]; then sh $EXEC_SCRIPT; else clear; exec init a; fi
		;;

	1)
		mkpart
		debug
		if [ "$EXEC_SCRIPT" != "" ]; then sh $EXEC_SCRIPT; else clear; exec init a; fi
		;;
	esac
	
	else
		mkpart
		debug
		if [ "$EXEC_SCRIPT" != "" ]; then sh $EXEC_SCRIPT; else clear; exec init a; fi

fi

exit 0
