#!/bin/sh
# --- This buffer is iso-8859-1  ---
# +==============================================================+
# || Markus Klappenbach						||
# || Thu Apr 10 14:44:44 CEST 2003				||
# || Thu Aug 28 16:06:30 CEST 2003				||
# || Tue Sep 20 17:50:21 CEST 2005 (Christian Kuelker: debug)   ||
# || License: GPL						||
# +==============================================================+
# restore_client ( aka 3.sh )
# runlevel 3 for yield.sh
# logging
LOG=/tmp/client.log
RLOG=/cipux/log/client.log
AUTOBOOTCFG=/cipux/conf/autoboot.cfg
DEMANDBOOTCFG=/cipux/conf/demandboot.cfg
AUTOBOOTSPLASH=/cipux/boot/autoboot.xpm.gz
DEMANDBOOTSPLASH=/cipux/boot/demandboot.xpm.gz
echo "=== client 3sh.log ===" > $LOG
# Sourcing Config Files
. /etc/pxes.conf
. /tmp/pxes.conf
. /etc/dhcpc/dhcpcd-eth0.info
. /tmp/${PXES_CLIENT_NAME}.conf 2>&1 >/dev/null

# export VARs
set -a

DEBUG=1

# debug mode
if [ "$DEBUG" = "1" ]; then
  echo "* enter DEBUG mode ">>$LOG
  export EXIT="t.sh put $LOG $RLOG"
else
  echo "* enter PRODUCTION mode">>$LOG
  export EXIT="init a"
fi

export EXEC_SCRIPT="$0"
SRV_IMG_DIR=/cipux/image
DIALOG=${DIALOG=dialog}
export DIALOGRC=/etc/dialogrc_restore
DATE=`date`
BS=1024
TARGET=/dev/hda1
COUNT=`sfdisk -s $TARGET |cut -d: -f2`
echo "- DATE:   $DATE"   >>$LOG
echo "- BS:     $BS"     >>$LOG
echo "- TARGET: $TARGET" >>$LOG
echo "- COUNT:  $COUNT"  >>$LOG
echo "- EXIT:   $EXIT"  >>$LOG

# DEBUG
# VAL=$(echo "$COUNT" | awk -- '{ $y=$0;  printf("x = %.0f bloecke", $x); print "";  $y = $x * 1024; printf("y = %.0f bytes",  $y); print "" }';)
# PRODUCTION
VAL=$(echo "$COUNT" | awk -- '{ $y=$0; $y = $x * 1024; printf("%.0f",  $y); print "" }';)
echo "- VAL:    $VAL" >>$LOG

tempfile=`tempfile 2>/dev/null` || tempfile=/tmp/test$$
trap "rm -f $tempfile" 0 1 2 5 15

backtitle="Restore Image [ CipWorX CipUX Version 2.0 << www.cipworx.org >> ]"

echo "
Image Wiederherstellung wird vorbereitet..." >/tmp/text.msg
	$DIALOG --sleep 2 --title "Status Information" --backtitle "$backtitle" --no-shadow --cr-wrap --infobox "`cat /tmp/text.msg`" 15 70
        	MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ; mount /mnt/hda2; fi
		mkfs.ext2 /dev/hda3 >>/tmp/MKFS.OUT 2>&1 &

	if [ ! -e /mnt/hda2/.initstatus ]; then
	echo "* create new partition table" >>$LOG
echo "
Partitionstabelle wurde nicht gefunden.
Partitionstabelle wird nun angelegt..." >/tmp/text.msg
	$DIALOG --sleep 2 --title "Status Information" --backtitle "$backtitle" --no-shadow --cr-wrap --infobox "`cat /tmp/text.msg`" 15 70
		t.sh get /cipux/script/2.sh /tmp/2.sh 2>&1 >/dev/null
		MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
		sh /tmp/2.sh
		exit 0
	else
	echo "* found partition table" >>$LOG
echo "
Partitionstabelle wurde gefunden.
Build `cat /mnt/hda2/.initstatus`" >/tmp/text.msg
	$DIALOG --sleep 2 --title "Status Information" --backtitle "$backtitle" --no-shadow --cr-wrap --infobox "`cat /tmp/text.msg`" 15 70
	fi

	MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ; mount /mnt/hda2; fi
	if [ "$(grep hda2 /proc/mounts)" == "" ]; then
	echo "ERROR: mount /mnt/hda2" >>$LOG
	t.sh put $LOG $RLOG
echo "
Die Cache Partition konnte nicht eingehangen werden.
berprfen Sie das Dateisystem und die Partitionierung oder starten
Sie das automatische Partitionierungstool." >/tmp/text.msg
	$DIALOG --exit-label "Neustart" --backtitle "$backtitle" --title "Fehler" --cr-wrap --no-shadow --textbox "/tmp/text.msg" 15 70
		case $? in 0) clear; exec $EXIT ;exit 0 ;; 255) echo "ESC pressed.";; esac
	else
	echo "* mounted /mnt/hda2" >>$LOG
echo "
Cache Partition wurde erfolgreich eingehangen.
Partition: $(grep hda2 /proc/mounts)" >/tmp/text.msg
	$DIALOG --sleep 2 --title "Status Information" --backtitle "$backtitle" --no-shadow --cr-wrap --infobox "`cat /tmp/text.msg`" 15 70
	fi

	if [ "$cipuxChecksum" == "<SE::cipuxChecksum>" ] || [ "$cipuxChecksum" == "0" ]; then
	echo "ERROR: no checksum for image" >>$LOG
	t.sh put $LOG $RLOG

echo "
In der Software Gruppe $cipuxImageSlotNumber [$cipuxImageSlotName]
existiert fr diesen Client, kein Image.
Client Daten: [ Hardware Typ $cipuxHardwareTypeNumber ($cipuxHardwareTypeName)]
Bitte erstellen Sie fr diesen Client ein Image.
Weitere Informationen hierzu finden Sie im Image Guide." >/tmp/text.msg
	$DIALOG --exit-label "Neustart" --backtitle "$backtitle" --title "Fehler" --cr-wrap --no-shadow --textbox "/tmp/text.msg" 15 70
		case $? in 0) clear; exec $EXIT ; exit 0 ;; 255) echo "ESC pressed."; exit 0;; esac
	fi

	# checksum verification
echo "
Image: $CIPUX_IMAGE [$cn]
Prfsumme wird verifiziert, bitte warten...

Dieser Vorgang kann etwas dauern." >/tmp/text.msg
		echo "$cipuxChecksum" >/tmp/cipuxChecksum.sig 2>&1
		CHECKSUM_FILEEXTENSION=$(cat /tmp/cipuxChecksum.sig |cut -d. -f2)
	$DIALOG --sleep 2 --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --infobox "`cat /tmp/text.msg`" 15 70
		if [ -e /mnt/hda2/$cipuxImageSlotNumber.$CHECKSUM_FILEEXTENSION ]; then
		cd /mnt/hda2; md5sum -c /tmp/cipuxChecksum.sig |cut -d" " -f2 >/tmp/CHECKSUM 2>&1 &
		while [ -n "`ps ax --noheaders |grep -v grep |grep md5sum`" ]; do echo -e -n '.'; sleep 2; echo -n $$ >/tmp/loop.pid 2>&1; done
		if [ -s /tmp/loop.pid ]; then kill -INT $(cat /tmp/loop.pid); fi
		export CHECK=$(cat /tmp/CHECKSUM)
		else
		export CHECK="FAILED"
		fi
	if [ "$CHECK" != "OK" ];then
		echo "ERROR: checksum failed!" >>$LOG
		echo "
		Prfsumme fr $CIPUX_IMAGE: $CHECK" >/tmp/text.msg
	$DIALOG --sleep 2 --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --infobox "`cat /tmp/text.msg`" 15 70
echo "
Lsche /mnt/hda2/$cipuxImageSlotNumber.$cipuxImageType..." >/tmp/text.msg
	$DIALOG --sleep 2 --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --infobox "`cat /tmp/text.msg`" 15 70
		rm -f /mnt/hda2/$cipuxImageSlotNumber.$cipuxImageType
	else
		echo "* checksum OK" >>$LOG
echo "
Prfsumme fr $CIPUX_IMAGE: $CHECK" >/tmp/text.msg
	$DIALOG --sleep 2 --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --infobox "`cat /tmp/text.msg`" 15 70
	fi
	# end checksum verification

	if [ "$cipuxImageType" != "$CHECKSUM_FILEEXTENSION" ]; then
	echo "ERROR: image data (in database) inconsistent" >>$LOG
	t.sh put $LOG $RLOG
echo "
Das Image [$cn] enthlt inkonsistente Daten.
Der Imagetyp (Fileextension) des Images [$cipuxImageType]
und der Imagetyp der Prfsumme [$CHECKSUM_FILEEXTENSION] stimmen nicht berein.
Dieser Fehler kann nur in der Datenbank selbst behoben werden.
Bitte wenden Sie sich mit dieser Fehlermeldung an Ihren Support." >/tmp/text.msg
	$DIALOG --exit-label "Neustart" --backtitle "$backtitle" --title "Fehler" --cr-wrap --no-shadow --textbox "/tmp/text.msg" 15 70
		case $? in 0) clear; exec $EXIT ; exit 0 ;; 255) echo "ESC pressed."; exit 0;; esac
	fi

# Syslog
# +==============================================================================================+
	MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ;  mount /mnt/hda2; fi
	echo "VAL: $VAL" >/mnt/hda2/3.sh.log 2>&1
	echo "CHECKSUM_FILEEXTENSION: $CHECKSUM_FILEEXTENSION" >>/mnt/hda2/3.sh.log 2>&1
	echo "CHECK: $CHECK" >>/mnt/hda2/3.sh.log 2>&1
	echo "CIPUX_IMAGE: $CIPUX_IMAGE" >>/mnt/hda2/3.sh.log 2>&1
	echo "cipuxImageNumber: $cn" >>/mnt/hda2/3.sh.log 2>&1
	echo "Blocksize: $BS" >>/mnt/hda2/3.sh.log 2>&1
	echo "Count: $COUNT" >>/mnt/hda2/3.sh.log 2>&1
	echo "Target: $TARGET" >>/mnt/hda2/3.sh.log 2>&1
	MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
# +==============================================================================================+

echo "* image type is [$cipuxImageType]">>$LOG
case $? in
  0)
        case "$cipuxImageType" in
        	tgz)
        		echo "* image type eq tgz">>$LOG
			MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ;  mount /mnt/hda2; fi
		if [ ! -e /mnt/hda2/$cipuxImageSlotNumber.dd ]; then
			echo "* client boot block [$cipuxImageSlotNumber.dd] not found">>$LOG
			echo "
			Client Bootblock wurde nicht gefunden,
			Starte download vom Server..." >/tmp/text.msg
        		cd /mnt/hda2
			t.sh get /$CIPUX_IMAGE.dd $cipuxImageSlotNumber.dd 2>&1 >/dev/null
		$DIALOG --sleep 2 --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --infobox "`cat /tmp/text.msg`" 15 70
			echo "* load from server [t.sh get /$CIPUX_IMAGE.dd $cipuxImageSlotNumber.dd]">>$LOG
		fi
			echo "* make filesystem msdos ">>$LOG
			mkfs.msdos /dev/hda1 2>&1 >/dev/null
			echo "* copy boot block [$cipuxImageSlotNumber.dd] to /dev/hda1 ">>$LOG
			dd if=/mnt/hda2/$cipuxImageSlotNumber.dd of=/dev/hda1 bs=512 count=1 conv=notrunc 1>&2 2>/dev/null
			MST=$(df |grep "hda1"); if [ -z "$MST" ]; then cd / ;  mount /mnt/hda1; fi
		if [ ! -e /mnt/hda2/$cipuxImageSlotNumber.tgz ]; then
			echo "* load image from server [$cipuxImageSlotNumber.tgz]">>$LOG
			echo "Image wird vom Server kopiert, bitte warten..." >/tmp/text.msg
        		cd /mnt/hda2
			echo  " - t.sh get /$CIPUX_IMAGE.tgz $cipuxImageSlotNumber.tgz">>$LOG
			t.sh get /$CIPUX_IMAGE.tgz $cipuxImageSlotNumber.tgz 2>&1 >/dev/null &
               	$DIALOG --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --infobox "`cat /tmp/text.msg`" 15 70
                	while [ -n "`ps ax --noheaders |grep -v grep |grep t.sh`" ]; do
                        	echo -e -n "$( netstat -s -u | grep -v grep | grep "packets sent" | cut -d" " -f5)\r\c"
                	done | pv -N "applied time" -t -p -f -i 0.2 2>&1 >/dev/null
		fi
			cd /mnt/hda2
			echo "* restore image [$cipuxImageSlotNumber.tgz]">>$LOG
			echo "* pwd ">>$LOG
			pwd >>$LOG
			echo "* df -h ">>$LOG
			df -h >>$LOG
			export SIZE_VAL=`zcat -l $cipuxImageSlotNumber.tgz |grep -v grep |grep $cipuxImageSlotNumber.tar |awk '{print $2}'`
			echo "SIZE_VAL: $SIZE_VAL" >>$LOG
			cd /mnt/hda1 ; (zcat /mnt/hda2/$cipuxImageSlotNumber.tgz 2>/dev/null | pv -n -s $SIZE_VAL | tar xf - ) 2>&1 | \
		$DIALOG --backtitle "$backtitle" --gauge 'Image Wiederherstellung Fortschritt' 7 70
			cd /
			echo "* TODO (write swich: auto/demand) copy auto reinstall mode /opt/deploy/autoboot.cfg /mnt/hda1/">>$LOG
			t.sh get $AUTOBOOTCFG /tmp/autoboot.cfg
			if [ "$DEBUG" = "1" ]; then
			  echo "* do not copy, because DEBUG">>$LOG
			else
			  cp -f /opt/deploy/autoboot.cfg /mnt/hda1/
			fi
			echo "* copy demand reinstall mode /tmp/demandboot.cfg /mnt/hda1/"
			t.sh get $DEMANDBOOTCFG /tmp/demandboot.cfg
			if [ "$DEBUG" = "1" ]; then
			  echo "* do not copy, because DEBUG">>$LOG
			else
			  cp -f /tmp/demandboot.cfg /mnt/hda1/
			fi
			echo "* copy demand reinstall mode /tmp/demandboot.xpm.gz /mnt/hda1/"
			t.sh get $DEMANDBOOTSPLASH /tmp/demandboot.xpm.gz
			if [ "$DEBUG" = "1" ]; then
			  echo "* do not copy, because DEBUG">>$LOG
			else
			  cp -f /tmp/demandboot.xpm.gz /mnt/hda1/
			fi
			echo "* copy auto reinstall mode /tmp/autoboot.xpm.gz /mnt/hda1/"
			t.sh get $DEMANDBOOTSPLASH /tmp/autoboot.xpm.gz
			if [ "$DEBUG" = "1" ]; then
			  echo "* do not copy, because DEBUG">>$LOG
			else
			  cp -f /tmp/autoboot.xpm.gz /mnt/hda1/
			fi

			echo "CIPUX_MASTER Value is: $cipuxMaster"
		if [ "$cipuxMaster" == "TRUE" ]; then
		        echo "* MASTER CLIENT:" >>$LOG
		        echo "* rm -f /mnt/hda1/98refine.reg" >>$LOG
		        if [ ! -e /mnt/hda1/autexec.ori ]; then 
			  cp /mnt/hda1/autexec.bat /mnt/hda1/autoexec.ori
			  echo "cp /mnt/hda1/autexec.bat /mnt/hda1/autoexec.ori " >>$LOG
			fi
			echo "save the autoxec.bat to autoexec.ori ">>$LOG
		else
			echo "* RESTORE CLIENT:" >>$LOG
			#cp -f /opt/deploy/98refine.reg /mnt/hda1/
			#echo "cp -f /opt/deploy/98refine.reg /mnt/hda1/">>$LOG
			#cp -f /opt/deploy/autoexec.bat /mnt/hda1/
			#echo "-f /opt/deploy/autoexec.bat /mnt/hda1/">>$LOG
			#cp -f /opt/deploy/Beenden.lnk /mnt/hda1/windows/Startmen/
			#echo "/opt/deploy/Beenden.lnk /mnt/hda1/windows/Startmen/">>$LOG
			t.sh get /cipux/conf/98refine.reg /mnt/hda1/98refine.reg
			echo "t.sh get /cipux/conf/98refine.reg /mnt/hda1/98refine.reg ">>$LOG
			t.sh get /cipux/conf/autoexec.addon /mnt/hda1/autoexec.addon
			echo "t.sh get /cipux/conf/autoexec.addon /mnt/hda1/autoexec.addon">>$LOG
		        if [ ! -e /mnt/hda1/autexec.ori ]; then 
			  cp -f /mnt/hda1/autexec.bat /mnt/hda1/autoexec.ori
			  echo " cp -f /mnt/hda1/autexec.bat /mnt/hda1/autoexec.ori " >>$LOG
			fi
			echo "save the autoiexec.bat to autoexec.ori ">>$LOG
                        cat /mnt/hda1/autoexec.addon >> /mnt/hda1/autoexec.bat
			echo "cat /mnt/hda1/autoexec.addon >> /mnt/hda1/autoexec.bat ">>$LOG
			
		fi
			echo "* change client name to [${PXES_CLIENT_NAME}]">>$LOG
			sed -e "s/<SE::NAME>/${PXES_CLIENT_NAME}/g" /opt/deploy/name.reg >/mnt/hda1/name.reg
			echo "* restored image">>$LOG
			t.sh put $LOG $RLOG
			echo "
			Image wurde erfolgreich restauriert !
			System wird neu gestartet..." >/tmp/text.msg
		$DIALOG --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --infobox "`cat /tmp/text.msg`" 10 70
			MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
			MST=$(df |grep "hda1"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda1; fi
			clear; exec $EXIT
			;;

		cci)
			MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ; mount /mnt/hda2; fi
		if [ "$CHECK" != "OK" ]; then
			echo "
			Image wird vom Server kopiert, bitte warten..." >/tmp/text.msg
			cd /mnt/hda2; t.sh get /$CIPUX_IMAGE.cci $cipuxImageSlotNumber.cci 2>&1 >/dev/null &
		$DIALOG --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --infobox "`cat /tmp/text.msg`" 15 70
                        while [ -n "`ps ax --noheaders |grep -v grep |grep t.sh`" ]; do
                                echo -e -n "$( netstat -s -u | grep -v grep | grep "packets sent" | cut -d" " -f5)\r\c"
                        done | pv -N "applied time" -t -p -f -i 0.2 2>&1 >/dev/null
                fi

		# gzip compressed Image restore
			cd /mnt/hda2; (zcat $cipuxImageSlotNumber.cci 2>/dev/null | pv -n -s $VAL | dd of=$TARGET bs=$BS count=$COUNT 2>/dev/null) \
			2>&1 | $DIALOG --backtitle "$backtitle" --gauge '  Image wird restauriert, bitte warten ... ' 7 70
			t.sh put $LOG $RLOG
			echo "
			Image wurde erfolgreich restauriert !
			System wird neu gestartet..." >/tmp/text.msg
		$DIALOG --sleep 3 --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --infobox "`cat /tmp/text.msg`" 10 70
			MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
			clear; exec $EXIT
                        ;;
		esac
		;;

	1)
		t.sh put $LOG $RLOG
		clear; exec $EXIT
		;;
esac

t.sh put $LOG $RLOG
exit 0

