#!/bin/bash
# +==============================================================+
# || Markus Klappenbach						||
# || Thu Apr 10 14:44:44 CEST 2003				||
# || Thu Jul 17 11:15:49 CEST 2003				||
# || Wed Sep 21 02:11:22 CEST 2005 (ckuelker)                   ||
# || License: GPL						||
# +==============================================================+
# create_image ( aka 4.sh )
# Runlevel 4 for create.sh
#
# Sourcing Config Files
. /etc/pxes.conf
. /tmp/pxes.conf
. /etc/dhcpc/dhcpcd-eth0.info
. /tmp/${PXES_CLIENT_NAME}.conf 2>&1 >/dev/null
export EXEC_SCRIPT="$0"
SRV_IMG_DIR=/cipux/image
MNG="/etc/bootsplash/themes/linux.mng"
MNG_BOUNCE="/etc/bootsplash/themes/bounce.mng"
DIALOG=${DIALOG=dialog}
export DIALOGRC=/etc/dialogrc_create
DATE=`date +20%y-%m-%d`
SOURCE=/dev/hda1
DISK=/dev/hda
BS=1024
COUNT=`sfdisk -s $SOURCE |cut -d: -f2`
FSTYPE=`sfdisk -l $DISK | grep -v grep | grep $SOURCE | awk 'BEGIN {FS = " "} {print $8}'`

# DEBUG
# VAL=$(echo "$COUNT" | awk -- '{ $y=$0;  printf("x = %.0f bloecke", $x); print "";  $y = $x * 1024; printf("y = %.0f bytes",  $y); print "" }';)
# PRODUCTION
VAL=$(echo "$COUNT" | awk -- '{ $y=$0; $y = $x * 1024; printf("%.0f",  $y); print "" }';)

#while [ 1 ]; do
#	echo -e -n '|\r\c'
#	echo -e -n '/\r\c'
#	echo -e -n '-\r\c'
#	echo -e -n '\\\r\c'
#done

backtitle="Create Image [ CipWorX CipUX Version 2.0 << www.cipworx.org >> ]"
tempfile=`tempfile 2>/dev/null` || tempfile=/tmp/test$$
trap "rm -f $tempfile" 0 1 2 5 15

# checking if Mount on Cache Partition succeeds
MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ; mount /mnt/hda2; fi
if [ "$(grep hda2 /proc/mounts)" == "" ]; then
echo "
Die Cache Partition konnte nicht eingehangen werden.
berprfen Sie das Dateisystem und die Partitionierung oder starten
Sie das automatische Partitionierungstool." >/tmp/text.msg
	$DIALOG --exit-label "Neustart" --backtitle "$backtitle" --title "Fehler" --no-collapse --cr-wrap --no-shadow --textbox "/tmp/text.msg" 15 70
		case $? in 0) clear; init a ;exit 0 ;; 255) echo "ESC pressed.";; esac
        else
echo "
Cache Partition wurde erfolgreich eingehangen.
Partition: $(grep hda2 /proc/mounts)" >/tmp/text.msg
        $DIALOG --sleep 2 --title "Status Information" --backtitle "$backtitle" --no-shadow --cr-wrap --infobox "`cat /tmp/text.msg`" 15 70
        fi


	# Syslog
	# +==============================================================================================+
	MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ; mount /mnt/hda2; fi
	echo "Source: $SOURCE" 2>&1 >/mnt/hda2/4.sh.log
	echo "Blocksize: $BS" 2>&1 >>/mnt/hda2/4.sh.log
	echo "Count: $COUNT" 2>&1 >>/mnt/hda2/4.sh.log
	echo "Val: $VAL" 2>&1 >>/mnt/hda2/4.sh.log
	echo "cipuxImageSlotNumber: $cipuxImageSlotNumber" 2>&1 >>/mnt/hda2/4.sh.log
	MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
	# +==============================================================================================+



if [ "$cipuxImageType" == "<SE::cipuxImageType>" ];then
echo "
Das Image wurde nicht mit dem CipUX Administrationswerkzeug konfiguriert.
Fhren Sie diesen Schritt zuerst aus bevor Sie das Image generieren. " >/tmp/text.msg
	$DIALOG --exit-label "Neustart" --backtitle "$backtitle" --title "Fehler" --no-collapse --cr-wrap --no-shadow --textbox "/tmp/text.msg" 15 70
		case $? in 0) clear; init a ;exit 0 ;; 255) echo "ESC pressed.";; esac

	elif [ "$cipuxImageSlotProtect" == "TRUE" ];then
echo "
Die ausgewhlte Softwaregruppe ist geschtzt. Bitte heben Sie den
Schutz auf oder whlen Sie ein anderes Image aus." >/tmp/text.msg
	$DIALOG --exit-label "Neustart" --backtitle "$backtitle" --title "Fehler" --no-collapse --cr-wrap --no-shadow --textbox "/tmp/text.msg" 15 70
        	case $? in 0) clear; init a ;exit 0 ;; 255) echo "ESC pressed.";; esac

	elif [ "$cipuxMaster" == "FALSE" ];then
echo "
Clientmodus: $cipuxMaster
Bitte schalten Sie den Client mit CAT in den Mastermodus und
whlen Sie die richtige Softwaregruppe im Clientadmin aus.  " >/tmp/text.msg
	$DIALOG --exit-label "Neustart" --backtitle "$backtitle" --title "Fehler" --no-collapse --cr-wrap --no-shadow --textbox "/tmp/text.msg" 15 70
                case $? in 0) clear; init a ;exit 0 ;; 255) echo "ESC pressed.";; esac
	else


	$DIALOG --defaultno --title "Create Image Information" \
        --backtitle "$backtitle" --cr-wrap --nocancel --tab-correct --no-collapse --no-shadow --yesno "\

	Wollen Sie das Image mit den folgenden Werten erstellen?

	Image Daten:
	=================================================================
	Hardware Typ:      $cipuxHardwareTypeNumber [$cipuxHardwareTypeName]
	Software Gruppe:   $cipuxImageSlotNumber [$cipuxImageSlotName]
	Image:             $cn [$cipuxImageName]
	Image Typ:         $cipuxImageType" 15 70

case $? in
  0)
	case "$cipuxImageType" in
	tgz)
		MST=$(df |grep "hda1"); if [ -z "$MST" ]; then cd / ; mount /mnt/hda1; fi
		MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ; mount /mnt/hda2; fi
		rm -f /mnt/hda1/windows/*.swp
		# ckuelker: get list for excluding files from tar achive
		t.sh get /cipux/conf/exclude_files.list /mnt/hda2/exclude_files.list
		touch /tmp/tmp1.$$
		if [ -n /proc/fb ]; then fbmngplay -x 400 -y 700 $MNG_BOUNCE 2>&1 >/dev/null & fi; sleep 5 &
		$DIALOG --title "Image wird erstellt, bitte warten..." --backtitle "$backtitle" --no-kill --no-shadow \
		--tailboxbg /tmp/tmp1.$$ 15 70 2>$tempfile
		tar -X /mnt/hda2/exclude_files.list -C /mnt/hda1 -cvzf /mnt/hda2/$cipuxImageSlotNumber.tgz . >/tmp/tmp1.$$ 2>&1
		MST=$(df |grep "hda1"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda1; fi
        	dd if=/dev/hda1 of=/mnt/hda2/$cipuxImageSlotNumber.dd bs=512 count=1 >>/tmp/tmp1.$$ 2>&1
		if [ -n "`ps ax --noheaders |grep -v grep |grep fbmngplay`" ]; then killall fbmngplay 2>&1 >/dev/null; fi

                touch /tmp/tmp2.$$
        	echo "+=======================================================================+" >/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0

                echo -n "Syncing Disks..." >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0
                sync; sleep 2
                echo "fertig" >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0

		echo -n "Image wird auf den Server kopiert, bitte warten..." >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0
                cd /mnt/hda2; if [ -n /proc/fb ]; then fbmngplay -x 10 -y 160 $MNG 2>&1 >/dev/null & fi; sleep 5 &
		t.sh put $cipuxImageSlotNumber.tgz /$CIPUX_IMAGE.tgz 2>&1 >/dev/null && t.sh put $cipuxImageSlotNumber.dd /$CIPUX_IMAGE.dd 2>&1 >/dev/null &
                while [ -n "`ps ax --noheaders |grep -v grep |grep t.sh`" ]; do
                        echo -e -n "$( netstat -s -u | grep -v grep | grep "packets sent" | cut -d" " -f5)\r\c"
                done | pv -N "applied time" -t -p -f -i 0.2 2>&1 >/dev/null
                if [ -n "`ps ax --noheaders |grep -v grep |grep fbmngplay`" ]; then killall fbmngplay 2>&1 >/dev/null; fi
                sleep 2
                echo "fertig" >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0

echo -n "Client Konfiguration wird erzeugt..." >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0
                cat /tmp/${PXES_CLIENT_NAME}.conf >>/tmp/$cipuxImageSlotNumber.cfg 2>&1
                echo "export cipuxCreationDate='$DATE'" >>/tmp/$cipuxImageSlotNumber.cfg 2>&1
                sleep 2
                echo "fertig" >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0

                echo -n "Image:[$cn]: Prfsumme wird berechnet und gespeichert..." >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0
		sync
		cd /mnt/hda2; md5sum $cipuxImageSlotNumber.tgz >/tmp/$cipuxImageSlotNumber.md5 2>&1 &
                while [ -n "`ps ax --noheaders |grep -v grep |grep md5sum`" ]; do echo -e -n ''; sleep 3; echo -n $$ >/tmp/loop.pid 2>&1; done
		sync
                echo "export cipuxChecksum='$(cat /tmp/$cipuxImageSlotNumber.md5)'" >>/tmp/$cipuxImageSlotNumber.cfg 2>&1
                if [ -s /tmp/loop.pid ]; then kill -INT $(cat /tmp/loop.pid); fi
                sleep 2
                echo "fertig" >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0

                echo -n "Client Konfiguration wird auf dem Server gespeichert..." >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0
                cd /tmp; t.sh put $cipuxImageSlotNumber.cfg /$CIPUX_IMAGE.cfg 2>&1 >/dev/null
                sleep 2
                echo "fertig" >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0

        	echo "+=======================================================================+" >>/tmp/tmp2.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp2.$$`" 0 0

                sleep 5
		killall dialog
		echo "
			Image wurde erfolgreich erstellt !
			Bitte warten Sie ca. 10 - 15 Minuten bevor Sie
			das neue Image auf die Clients verteilen." >/tmp/text.msg
                $DIALOG --clear --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --msgbox "`cat /tmp/text.msg`" 15 70
                MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
                clear; exec init a; exit 0
		;;
	cci)
		MST=$(df |grep "hda2"); if [ -z "$MST" ]; then cd / ;  mount /mnt/hda2; fi
		# uncompressed Image
		# (dd if=$SOURCE bs=$BS count=$COUNT 2>/dev/null | pv -n -s $VAL | dd of=/mnt/hda2/$cipuxImageSlotNumber.cci 2>/dev/null) 2>&1 | \
		# dialog --backtitle "$backtitle" --gauge "  Image wird erstellt, bitte warten ..." 7 70
		# gzip compressed Image
		if [ -n /proc/fb ]; then fbmngplay -x 400 -y 700 $MNG_BOUNCE 2>&1 >/dev/null & fi ; sleep 5 &
		(dd if=$SOURCE bs=$BS count=$COUNT 2>/dev/null | pv -n -s $VAL | gzip >/mnt/hda2/$cipuxImageSlotNumber.cci) 2>&1 |dialog --backtitle \
		"$backtitle" --gauge "  Image wird erstellt, bitte warten ..." 7 70
		if [ -n "`ps ax --noheaders |grep -v grep |grep fbmngplay`" ]; then killall fbmngplay 2>&1 >/dev/null; fi

		touch /tmp/tmp1.$$
        	echo "+=======================================================================+" >/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0

		echo -n "Syncing Disks..." >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0
		sync; sleep 2
        	echo "fertig" >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0

                echo -n "Image wird auf den Server kopiert, bitte warten..." >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0
		cd /mnt/hda2; if [ -n /proc/fb ]; then fbmngplay -x 10 -y 160 $MNG 2>&1 >/dev/null & fi; sleep 5 &
                t.sh put $cipuxImageSlotNumber.cci /$CIPUX_IMAGE.cci 2>&1 >/dev/null &
		while [ -n "`ps ax --noheaders |grep -v grep |grep t.sh`" ]; do
                        echo -e -n "$( netstat -s -u | grep -v grep | grep "packets sent" | cut -d" " -f5)\r\c"
                done | pv -N "applied time" -t -p -f -i 0.2 2>&1 >/dev/null
		if [ -n "`ps ax --noheaders |grep -v grep |grep fbmngplay`" ]; then killall fbmngplay 2>&1 >/dev/null; fi
		sleep 2
                echo "fertig" >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0

                echo -n "Client Konfiguration wird erzeugt..." >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0
		cat /tmp/${PXES_CLIENT_NAME}.conf >>/tmp/$cipuxImageSlotNumber.cfg 2>&1
                echo "export cipuxCreationDate='$DATE'" >>/tmp/$cipuxImageSlotNumber.cfg 2>&1
		sleep 2
                echo "fertig" >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0

                echo -n "Image:[$cn]: Prfsumme wird berechnet und gespeichert..." >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0
                cd /mnt/hda2; md5sum $cipuxImageSlotNumber.cci >/tmp/$cipuxImageSlotNumber.md5 2>&1 &
                while [ -n "`ps ax --noheaders |grep -v grep |grep md5sum`" ]; do echo -e -n ''; sleep 3; echo -n $$ >/tmp/loop.pid 2>&1; done
                echo "export cipuxChecksum='$(cat /tmp/$cipuxImageSlotNumber.md5)'" >>/tmp/$cipuxImageSlotNumber.cfg 2>&1
                if [ -s /tmp/loop.pid ]; then kill -INT $(cat /tmp/loop.pid); fi
		sleep 2
                echo "fertig" >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0

                echo -n "Client Konfiguration wird auf dem Server gespeichert..." >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0
                cd /tmp; t.sh put $cipuxImageSlotNumber.cfg /$CIPUX_IMAGE.cfg 2>&1 >/dev/null
		sleep 2
                echo "fertig" >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0

        	echo "+=======================================================================+" >>/tmp/tmp1.$$
$DIALOG --title "Status Information" --backtitle "$backtitle" --aspect 35 --no-collapse --cr-wrap --no-shadow --infobox "`cat /tmp/tmp1.$$`" 0 0

		sleep 5
		killall dialog
		echo "
		Image wurde erfolgreich erstellt !
		Bitte warten Sie ca. 10 - 15 Minuten bevor Sie
		das neue Image auf die Clients verteilen." >/tmp/text.msg
$DIALOG --clear --title "Status Information" --backtitle "$backtitle" --cr-wrap --no-shadow --msgbox "`cat /tmp/text.msg`" 15 70
		MST=$(df |grep "hda2"); if [ -n "$MST" ]; then cd / ; umount /mnt/hda2; fi
		clear; #exec init a; exit 0
		;;

	esac
	;;
  1)
	clear; #exec init a; exit 0
	;;
esac
fi

exit 0

