#!/usr/bin/perl -w

use strict;
use IO::Socket;
use threads;
use threads::shared;
use Config;

$Config{useithreads} or die "Recompile Perl with threads to run this program.";



my $clientssock = new IO::Socket::INET (
                                 LocalHost => 'localhost',
                                 LocalPort => '7676',
                                 Proto => 'tcp',
                                 Listen => SOMAXCONN,
                                 Reuse => 1,
                                );
die "Could not create client socket: $!\n" unless $clientssock;

my $i=0;

my $seq : shared=0;

my $thread = threads -> new(sub {
  while (sleep 10) {
   $seq = qx(cipux_get_value -x CipUX -e cipuxVariable -v CipUX_Notify_Clients);
  }
});

while (my $client = $clientssock -> accept()) {
 my $thread = threads -> new(\&client_thread, $client, $i++);
}

sub client_thread {
 my $client = shift;
 my $client_nr = shift;
 my $oldseq = $seq;
 while (sleep 1) {
  if ($seq != $oldseq) {
   print $client ".";
  }
  $oldseq = $seq;
 }
 close($client);
}
