#! /bin/sh
### BEGIN INIT INFO
# Provides:          cipux-rpcd
# Required-Start:    $syslog
# Required-Stop:     $syslog
# Should-Start:      $local_fs
# Should-Stop:       $local_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: fixme: needs to be filled by C14r
# Description:       fixme: needs to be filled by C14r or someone else who knows
#                    more description here... (and a question about above: is 
#                    syslog really required?)   
### END INIT INFO

set -e

# /etc/init.d/cipux-rpcd: start and stop the CipUX RPC daemon

# start script called cipux-rpcd
# the deamon called cipux_rpcd

test -x /usr/sbin/cipux_rpcd || exit 0
#( /usr/sbin/cipux_rpcd -\? 2>&1 | grep -q CipUX ) 2>/dev/null || exit 0

if test -f /etc/default/cipux; then
    . /etc/default/cipux
fi

check_for_no_start() {
    # forget it if we're trying to start, and /etc/cipux/cipux-rpcd_not_to_be_run exists
    if [ -e /etc/cipux/cipux-rpcd_not_to_be_run ]; then 
	echo "CipUX RPC daemon server not in use (/etc/cipux/cipux-rpcd_not_to_be_run)"
	exit 0
    fi
}

check_privsep_dir() {
    # Create the PrivSep empty dir if necessary
    if [ ! -d /var/run/cipux_rpcd ]; then
	mkdir /var/run/cipux_rpcd
	chmod 0755 /var/run/cipux_rpcd
    fi
}

check_config() {
    if [ ! -e /etc/cipux/cipux-rpcd_not_to_be_run ]; then
	/usr/sbin/cipux_rpcd -t || exit 1
    fi
}

check_for_already_started() {
  # do not change that easily, because pidof tend to kill the script!
  if [ -z $(pidof -sx cipux_rpcd) ]; then
    echo -n ""
  else
    pid=$(pidof -sx cipux_rpcd)
    echo "Will not start deamon, because it is already started with PID $pid"
    exit 1
  fi
}

export PATH="${PATH:+$PATH:}/usr/sbin:/sbin"

case "$1" in
  start)
	check_for_no_start
	check_for_already_started
	check_privsep_dir
        echo -n "Starting CipUX RPC daemon server: cipux-rpcd"
	start-stop-daemon --background --make-pidfile --start --quiet --pidfile /var/run/cipux_rpcd.pid --exec /usr/sbin/cipux_rpcd
	sleep 10
	echo `pidof -sx cipux_rpcd` >  /var/run/cipux_rpcd.pid
        echo "."
	;;
  stop)
        echo -n "Stopping CipUX RPC daemon server: cipux-rpcd"
	start-stop-daemon --stop --quiet --oknodo --pidfile /var/run/cipux_rpcd.pid
        echo "."
	;;

  reload|force-reload)
	check_for_no_start
	check_for_already_started
	check_config
        echo -n "Reloading CipUX RPC daemon server's configuration cipxurpcd"
	start-stop-daemon --stop --signal 1 --quiet --oknodo --pidfile /var/run/cipux_rpcd.pid --exec /usr/sbin/cipux_rpcd
        echo "."
	sleep 5
	echo `pidof -sx cipux_rpcd` >  /var/run/cipux_rpcd.pid
	;;

  restart)
	check_config
        echo -n "Restarting CipUX RPC daemon server: cipux-rpcd"
	start-stop-daemon --stop --quiet --oknodo --retry 30 --pidfile /var/run/cipux_rpcd.pid
        echo "."
	sleep 5
        check_for_no_start
	check_for_already_started
	check_privsep_dir
        sleep 1
	start-stop-daemon --background --make-pidfile --start --quiet --pidfile /var/run/cipux_rpcd.pid --exec /usr/sbin/cipux_rpcd
	echo `pidof -sx cipux_rpcd` >  /var/run/cipux_rpcd.pid
	echo "."
	;;

  *)
	echo "Usage: /etc/init.d/cipux-rpcd {start|stop|reload|force-reload|restart}"
	exit 1
esac

exit 0
