#! /bin/sh
### BEGIN INIT INFO
# Provides:          cipux-rpcdr
# Required-Start:    $syslog
# Required-Stop:     $syslog
# Should-Start:      $local_fs
# Should-Stop:       $local_fs
# Default-Start:     2 3 4 5
# Default-Stop:      0 1 6
# Short-Description: fixme: needs to be filled by C14r
# Description:       fixme: needs to be filled by C14r or someone else who knows
#                    more description here... (and a question about above: is 
#                    syslog really required?)   
### END INIT INFO

set -e

export PATH="${PATH:+$PATH:}/usr/sbin:/sbin"

# /etc/init.d/cipux-rpcdr: start and stop the CipUX RPC remote daemon

# start script called cipux-rpcdr
# the deamon called cipux_rpcdr (alias stunnel4)

test -x /usr/sbin/cipux_rpcdr || exit 0
#( /usr/sbin/cipux_rpcdr -\? 2>&1 | grep -q CipUX ) 2>/dev/null || exit 0

if test -f /etc/default/cipux; then
   . /etc/default/cipux
fi

check_for_no_start() {
   # forget it if we're trying to start, and /etc/cipux/cipux-rpcdr_not_to_be_run exists
   if [ -e /etc/cipux/cipux-rpcdr_not_to_be_run ]; then 
	   echo "CipUX RPC remote daemon server not in use (/etc/cipux/cipux-rpcdr_not_to_be_run)"
      exit 0
   fi
}

check_privsep_dir() {
   # Create the PrivSep empty dir if necessary
   if [ ! -d /var/run/cipux_rpcd ]; then
      mkdir /var/run/cipux_rpcd
      chmod 0755 /var/run/cipux_rpcd
   fi
}

check_config() {
   if [ ! -e /etc/cipux/cipux-rpcdr_not_to_be_run ]; then
      /usr/sbin/cipux_rpcdr -t || exit 1
   fi
}

check_for_already_started() {
  # do not change that easily, because pidof tend to kill the script!
  if [ -z $(pidof -s stunnel4) ]; then
    echo -n ""
  else
    pid=$(pidof -s stunnel4)
    echo "Will not start deamon, because it is already started with PID $pid"
    exit 1
  fi
}


case "$1" in
  start)
	check_for_no_start
	check_privsep_dir
        echo -n "Starting CipUX RPC daemon server: cipux-rpcdr"
	start-stop-daemon --background --make-pidfile --start --quiet --pidfile /var/run/cipux_rpcdr.pid --exec /usr/sbin/cipux_rpcdr ; sleep 1
        pid=`pidof usr/sbin/stunnel4 /etc/cipux/rpc/stunnel.conf`
        if [ $pid -ne `cat /var/run/cipux_rpcdr.pid` ]; then
		     echo $pid > /var/run/cipux_rpcdr.pid
        fi
        echo "."
	;;
  stop)
	echo -n "Stopping CipUX RPC daemon server: cipux-rpcdr"
        pid=`pidof usr/sbin/stunnel4 /etc/cipux/rpc/stunnel.conf`
        if [ $pid -ne `cat /var/run/cipux_rpcdr.pid` ]; then
	        echo $pid > /var/run/cipux_rpcdr.pid
        fi
        start-stop-daemon --stop --quiet --oknodo --pidfile /var/run/cipux_rpcdr.pid
        echo "."
	;;

  reload|force-reload)
	check_for_no_start
	check_config
        echo -n "Reloading CipUX RPC daemon server's configuration cipxurpcdr"
	start-stop-daemon --stop --signal 1 --quiet --oknodo --pidfile /var/run/cipux_rpcdr.pid --exec /usr/sbin/cipux_rpcdr
        echo "."
	sleep 5
	;;

  restart)
	check_config
        echo -n "Restarting CipUX RPC daemon server: cipux-rpcdr"
        pid=`pidof usr/sbin/stunnel4 /etc/cipux/rpc/stunnel.conf`
        if [ $pid -ne `cat /var/run/cipux_rpcdr.pid` ]; then
	        echo $pid > /var/run/cipux_rpcdr.pid
        fi
	start-stop-daemon --stop --quiet --oknodo --retry 30 --pidfile /var/run/cipux_rpcdr.pid
        echo "."
	sleep 5
	start-stop-daemon --background --make-pidfile --start --quiet --pidfile /var/run/cipux_rpcdr.pid --exec /usr/sbin/cipux_rpcdr
        pid=`pidof usr/sbin/stunnel4 /etc/cipux/rpc/stunnel.conf`
        if [ $pid -ne `cat /var/run/cipux_rpcdr.pid` ]; then
	        echo $pid > /var/run/cipux_rpcdr.pid
        fi
	;;

  *)
	echo "Usage: /etc/init.d/cipux-rpcdr {start|stop|reload|force-reload|restart}"
	exit 1
esac

exit 0
 
