#!/usr/bin/perl -w
# +=======================================================================+
# || /usr/sbin/cipux_rpcdr                                               ||
# ||                                                                     ||
# || Start the CipUX RPC remote daemon                                   ||
# ||                                                                     ||
# || (c) Copyright 2006 by Christian Kuelker                             ||
# || All rights reserved!                                                ||
# ||                                                                     ||
# || License: GPLv2                                                      ||
# ||                                                                     ||
# +=======================================================================+
use strict;

=pod

=head1 NAME

cipux_rpcdr - Version <[CIPUX::VERSION]>  2006-07-03 CipUX

=head1 SYNOPSIS

        cipux_rpcdr

=head1 ABSTRACT

This is the CipUX XML-RPC remote daemon for the CipUX::Task API. The 
daemon provides CipUX commands to RPC clients over SSL.

=head1 REQUIREMENTS

 stunnel4

=head1 DESCRIPTION

Start the cipux_rpcdr server after the cipux_rpcd server.

=head1 USAGE

 /usr/sbin/cipux_rpcdr

=cut

my $pid = 0;
$pid = qx(pidof -s /usr/sbin/stunnel4);
chomp($pid);
if($pid == 0){
  system("/usr/sbin/stunnel4 /etc/cipux/rpc/stunnel.conf");
}else{
  die "stunnel4 (alias cipux_rpcdr) is already running at $pid!\n";
}

#===========================================================================
#==== Documentation ========================================================
#===========================================================================

=head1 SEE ALSO

See the CipUX webpage and the manual at L<http://www.cipux.org>
See the mailing list L<http://www.cipux.org/mailman/listinfo/>

=head1 AUTHOR

Christian Kuelker  E<lt>christian.kuelker@cipworx.orgE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 1999-2006 by Christian Kuelker

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307 USA

=cut





