#!/bin/bash
# +=======================================================================+
# || /usr/lib/cipux/sbin/cipux_setup_rpc                                 ||
# ||                                                                     ||
# || Fills the XML-RPX Server LDAP values (ACLs,...)                     ||
# ||                                                                     ||
# || (c) Copyright 2006 by Christian Kuelker                             ||
# || All rights reserved                                                 ||
# ||                                                                     ||
# || License: GPLv2 or later                                             ||
# ||                                                                     ||
# +=======================================================================+

VERSION=<[CIPUX::VERSION]>

# delete the RPC configuration node
echo "* remove RPC configuration object from the LDAP server:"
/usr/lib/cipux/lal/cipux_del -x RPC > /dev/null 2>&1

# add the RPC configuration node
echo "* add RPC configuration object to the LDAP server:"

/usr/lib/cipux/lal/cipux_add -x --attribute cn=RPC

# init first  cipuxVariable
echo "* init first cipuxvariable"
/usr/lib/cipux/lal/cipux_set_value -x RPC  -e cipuxVariable -v 'CipUX_Producer=www.cipworx.org'

# add VERSION
echo "* setting CipUX Version of RPC server to $VERSION"
/usr/lib/cipux/lal/cipux_set_value -x RPC -a -e cipuxVariable -v "CipUX_RPC_Version=$VERSION"

# add admin,assistant 
# to the rpc functions
echo "* add default ACLs to the RPC configuration:"
for i in `cipux_task_list_rpc_functions`; do
  echo "  - add admin, assistant ACL to function $i"
  /usr/lib/cipux/lal/cipux_set_value -x RPC -a -e cipuxVariable -v "CipUX::Task::$i=all:admin assistant;self:none"
done
# add differen ACL to cipux_task_change_own_password
# functions with ACL "self is not none" must have ID (Examle: UID) as 
# the first paramater!
/usr/lib/cipux/lal/cipux_set_value -x RPC -a -e cipuxVariable -v "CipUX::Task::cipux_task_change_own_password=all:none;self:admin assistant teacher student"


