#!/usr/bin/perl -w
# +========================================================================+
# || /usr/lib/cipux/bot/cipux_bot_logon_ldap                              ||
# || A script, witch creates Windoze NT and Windoze 98 (an may be more)   ||
# || logon.bat scripts for group ('course') members.                      ||
# ||                                                                      ||
# ||                                                                      ||
# || Copyright: (c) 1999 - 2006  by Christian Kuelker all Rights reserved!||
# || Licence:   GPLv2 or later                                            ||
# ||                                                                      ||
# || Revision:  2006-08-08                                                ||
# ||                                                                      ||
# +========================================================================+
# META: use strict;

=pod

=head1 NAME

cipux_bot_logon_ldap - Version <[CIPUX::VERSION]>  2006-08-08 CipUX

=head1 SYNOPSIS

        cipux_bot_logon_ldap

=head1 ABSTRACT

The script logon_ldap_bot.pl parses the LDAP server for ou=user,uid=* 
and ou=course,uid=*
and builds for every user (in ou=user) a DOS logon script for
windoof 98 or windoof NT based on the users group membership in 
ou=course. The logon script uses the command 'net use' to
map DOS network drives. On top of that it also includes the mapping
of the default application share and the so called home drive. This
script should be executed by crond every 10 minutes. 

B<Default values:> for every user

CipUX 1.x:

	N: default application share ('cipan')
	H: home drive
	O-Z: group ('course') drives

CipUX 2.x:

        I: default application share ('cipan')
        H: home drive
	K-Z: group ('course') drives

B<Default values:> for cipadmin

        I or N:     default application share ('cipan')
        J:          source applicatin share ('sources')
        H:          home drive
        K-Z or O-Z: group ('course') drives

CipUX 3.x.x
        A-G: "free"
        H  : home drive
        I  : cipan = cippool application share
        J  : source application share
        K-Z: group, courses drives

Which default is used, you can see this by your cipan drive mapping.
Or from the config files.

A user XYZ will become a 'xyz.bat' network logon script.

=head1 REQUIREMENTS

	CipUX::CiBot

=cut

package cipux_bot_logon_ldap;

# +========================================================================+
my $PART=                  "Global VAR";#                                  |
# +========================================================================+
my $BRAND   = "cipworx";
my $PROJECT = "cipux";
my $SCRIPT  = "cipux_bot_logon_ldap";
my $VERSION = "<[CIPUX::VERSION]>";
my $BUILD   = "<[CIBOT::BUILD]>";

# some global vars:
# WARNING: not tested for CipUX 3.x!
my $CORRECT_LDAP = 0;
my $DEBUG = 0 ;

my @user = ();
my @course =();

# +========================================================================+
$PART=                       "Logging";#                                   |
# +========================================================================+
&log($SCRIPT,"="x76);
&log($SCRIPT,"BEGIN LOG: $SCRIPT $VERSION $BUILD");
my $cml = join(' ',@ARGV);
&log($SCRIPT," $SCRIPT $cml");

# +========================================================================+
$PART=                       "Modules";#                                   |
# +========================================================================+
use strict;
use CipUX::CiBot;
use Getopt::Std;

# +========================================================================+
$PART=                       "Environment";#                               |
# +========================================================================+

# use of environment module
my %opt=();
getopts("h",\%opt);

if(defined($opt{h})){usage();exit(0)}



#===========================================================================
$PART=                     "Get Config VAR";#                              |
#===========================================================================

&log($SCRIPT,"CipUX_Samba_Win_Netuse_Option   [$cipux{CipUX_Samba_Win_Netuse_Option}]");
&log($SCRIPT,"CipUX_Samba_Scipt_Dir           [$cipux{CipUX_Samba_Scipt_Dir}]");
&log($SCRIPT,"CipUX_Samba_Server              [$cipux{CipUX_Samba_Server}]");
&log($SCRIPT,"CipUX_Samba_Appl_Share_Name     [$cipux{CipUX_Samba_Appl_Share_Name}]");
&log($SCRIPT,"CipUX_Samba_Appl_Share_Drive    [$cipux{CipUX_Samba_Appl_Share_Drive}]");
&log($SCRIPT,"CipUX_Samba_Source_Share_Name   [$cipux{CipUX_Samba_Source_Share_Name}]");
&log($SCRIPT,"CipUX_Samba_Source_Share_Drive  [$cipux{CipUX_Samba_Source_Share_Drive}]");
&log($SCRIPT,"CipUX_Samba_Course_Drive_Start  [$cipux{CipUX_Samba_Course_Drive_Start}]");
&log($SCRIPT,"CipUX_Samba_Course_Drive_End    [$cipux{CipUX_Samba_Course_Drive_End}]");

# +========================================================================+
$PART=             "Configuration";#                                       |
# +========================================================================+

&log($SCRIPT,"[$PART] ...................... Begin Configuration ......................");

# Date as ISO-8601
my $date = `date --iso-8601`;
chomp($date);

# Time
my $time = `date  +\%T`;
chomp($time);

&log($SCRIPT,"[$PART] Time = $time");

# CipUX_Samba_Win_Netuse_Option = no means "" string (for win98)
if(lc($cipux{CipUX_Samba_Win_Netuse_Option}) eq "no"){
    &log($SCRIPT,"[$PART] NO CipUX_Samba_Win_Netuse_Option");
    $cipux{CipUX_Samba_Win_Netuse_Option}="";
}

# +========================================================================+
$PART=             "Main Part";#                                           |
# +========================================================================+

&log($SCRIPT,"[$PART] ...................... Beginne Main Part ......................");

# TODO: connect with LDAP and ask for home drive (if no NT)
# It is atomatic for NT
&log($SCRIPT,"[$PART] SMB HOME DRIVE: '$cipux{CipUX_Samba_Home_Drive}'");

my $cmd = "cipux_task_list_users";
&log($SCRIPT,"[$PART] CMD '$cmd'");
@user=`$cmd`;

$cmd = "cipux_task_list_courses";
&log($SCRIPT,"[$PART] CMD '$cmd'");
@course=`$cmd`;

print "ERROR: no user list, create user or check LDAP connection!" if $user[0]=~m/ERROR/;
print "ERROR: no group list, create group or check LDAP connection!" if $course[0]=~m/ERROR/;
if($user[0] =~/ERROR/){
  error('0155',$SCRIPT); #Can't bind to LDAP server! Check connection and setup!
  exit(1);
}
if($course[0] =~/ERROR/){
  error('0155',$SCRIPT); #Can't bind to LDAP server! Check connection and setup!
  exit(1);
}

#if($cipux{CipUX_Samba_Scipt_Dir} ne ""){
#  foreach my $u (@user){
#    my @out = `rm -f $cipux{CipUX_Samba_Scipt_Dir}/$u.bat`;
#  }
#}

my %user = ();
my %course=();
my @all_course=();

foreach my $course (@course){
  chomp($course);
  &log($SCRIPT,"========================================");
  &log($SCRIPT,"[$PART] COURSE: '$course'");
  #my @group = split("\t",$course);
  my @group = `cipux_task_list_user_members_of_course $course`;
  #push(@all_course,$group[0]);# to sumarize for the end, no need here
  push(@all_course,$course);# to sumarize for the end, no need here
  foreach my $obj (@group){
    chomp($obj);
    # obj = user, group[0]= groupname
    &log($SCRIPT,"[$PART] OBJ: '$obj'"); 
    #$user{$obj}{$group[0]}=1 if $obj ne $group[0];
    $user{$obj}{$course}=1 if $obj ne $course and $course ne 'nogroup';
    if($CORRECT_LDAP){
      # $course{$group[0]}{$obj}=1 if $obj ne $group[0];
      $course{$course}{$obj}=1 if $obj ne $course;
    }
  }
}

# if you want to correct the LDAP (might make sense for some migration)
# HoH:
if($CORRECT_LDAP){
  foreach my $course(sort keys %course){
    &log($SCRIPT,"DEBUG: COURSE (MEMBER) =======================");
    #print "COURSE LINE $course HASH $course{$course}\n";
    foreach my $c (sort keys %{ $course{$course} }){
      #print "COURSE $c VALUE $course{$course}{$c}\n";
      &log($SCRIPT,"$course ($c)");
      my $cmd1 = "set_value.pl -d -c '$course' -e 'memberUid' -v '$c'";
      my $cmd2 = "set_value.pl -a -c '$course' -e 'memberUid' -v '$c'";
      &log($SCRIPT,"CMD1: [$cmd1]");      
      &log($SCRIPT,"CMD2: [$cmd2]");      
       `$cmd1`;
       `$cmd2`;
    }
  }
}

# HoH:
if($DEBUG){
  foreach my $user(sort keys %user){
    &log($SCRIPT,"================================================");
    &log($SCRIPT,"USER $user HASH $user{$user}");
    &log($SCRIPT,"USER $user :");
    foreach my $group (sort keys %{ $user{$user} }){
      &log($SCRIPT,"GROUP $group VALUE $user{$user}{$group}");
    }
  }
}

# logon.bat files header
my @copyright=();
push(@copyright,"echo ======================================================= \cM\cJ");
push(@copyright,"echo Windoof NT/ Windoof 98 default login script \cM\cJ");
push(@copyright,"echo (c) Copyright 1999-2005, $date by \cM\cJ");
push(@copyright,"echo Christian Kuelker, Markus Klappenbach \cM\cJ");
push(@copyright,"rem  Created from $SCRIPT at $time h \cM\cJ");
push(@copyright,"echo ======================================================= \cM\cJ");
push(@copyright,"echo off \cM\cJ");
push(@copyright,"net use $cipux{CipUX_Samba_Appl_Share_Drive}: \\\\$cipux{CipUX_Samba_Server}\\$cipux{CipUX_Samba_Appl_Share_Name} $cipux{CipUX_Samba_Win_Netuse_Option}\cM\cJ");
push(@copyright,"net time \\\\$cipux{CipUX_Samba_Server} /set /yes \cM\cJ");    

# TODO (if file exists)
my @netlogonadds = `cat /etc/cipux/samba/netlogon.conf`;
foreach(@netlogonadds){
  s/^\s+$//;
  s/\n//;
  if($_ ne ""){
     push(@copyright,"$_\cM\cJ");
  }
}

my @every_object=();
push(@every_object,@user);
push(@every_object,@all_course);

# write other bat files
#foreach $user(sort keys %user){# this are all users, but also some non existing users! 
foreach my $user(@every_object){# this are all the real existing user + groups !
  if(defined($user)){
    if($user ne ''){
      chomp($user);
      my $drive = $cipux{CipUX_Samba_Course_Drive_Start};
      #print "USER $user HASH $user{$user}\n" if $DEBUG;
      &log($SCRIPT,"======================================================"); 
      &log($SCRIPT,"USER $user: ");
      my $file = "$cipux{CipUX_Samba_Scipt_Dir}/$user.bat";
      &log($SCRIPT,"FILE '$file'");
      open(BAT,">$file") or die "Can't write to file '$file'!\n";
        foreach(@copyright){ print BAT "$_" }
        print BAT "rem Login: '$user' \cM\cJ";
        print BAT "net use $cipux{CipUX_Samba_Home_Drive}: \\\\$cipux{CipUX_Samba_Server}\\$user $cipux{CipUX_Samba_Win_Netuse_Option}\cM\cJ";
        foreach my $group (sort keys %{ $user{$user} }){
          &log($SCRIPT,"GROUP $group VALUE $user{$user}{$group}");
          if($drive ne $cipux{CipUX_Samba_Course_Drive_End}){
            print BAT "net use $drive: \\\\$cipux{CipUX_Samba_Server}\\$group $cipux{CipUX_Samba_Win_Netuse_Option}\cM\cJ";
            $drive++;
          }
        }
        if($user eq "cipadmin"){
          print BAT "net use $cipux{CipUX_Samba_Source_Share_Drive}: \\\\$cipux{CipUX_Samba_Server}\\$cipux{CipUX_Samba_Source_Share_Name} $cipux{CipUX_Samba_Win_Netuse_Option}\cM\cJ";
        }
      close(BAT);
  `   chmod 500 $file`;
  `   chown $user:users $file`;
    }
  }
}

exit(0);


# +========================================================================+
$PART=              "Subroutines";#                                        |
# +========================================================================+

=pod

=head1 FUNCTIONS

=cut

# .........................................................................
# :                               usage                                   :
# .........................................................................

=pod

=head2 usage

Prints usage message.

=cut

sub usage{
  print "-"x76;
  print "\n";
  print "($SCRIPT)\n\n";
  print "  Build logon.bat scripts for all LDAP users on course bias\n\n";
  print "USAGE:\n";
  print "       $SCRIPT -h   : prints this help message\n";
  print "\n";
  print "-"x76;
  print "\n";
}


#===========================================================================
#==== Documentation ========================================================
#===========================================================================


=head1 SEE ALSO

See the CipUX webpage and the  manual at L<http://www.cipux.org>
See the mailing list L<http://www.cipux.org/mailman/listinfo/>

=head1 AUTHOR

Christian Kuelker  E<lt>christian.kuelker@cipworx.orgE<gt>

=head1 COPYRIGHT AND LICENSE

Copyright (C) 1999-2005 by Christian Kuelker 

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2, or (at
your option) any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,
MA 02110-1301, USA.

=cut

